<?php
/**
*
* @package DM Linkx
* @version $Id: functions_dm_linkx.php 168 2011-12-21 13:54:36Z femu $
* @copyright (c) 2009 femu - http://die-muellers.org
* @license http://opensource.org/licenses/gpl-license.php GNU Public License
*
*/

/**
* @ignore
*/
if (!defined('IN_PHPBB'))
{
	exit;
}

/**
* Check for new linkx (not yet approved linkx)
*/
function generate_unapproved()
{
	global $db, $user, $template, $auth;
	global $phpEx, $phpbb_root_path, $dm_linkx_path, $dm_linkx_config;

	$user->add_lang('mods/dm_linkx');

	$sql = 'SELECT COUNT(linkx_approval) AS linkx_unapproved
		FROM ' . DM_LINKX_TABLE . '
		WHERE linkx_approval = "0"';
	$result = $db->sql_query($sql);
	$linkx_unapproved = (int) $db->sql_fetchfield('linkx_unapproved');

	if ( $linkx_unapproved > 0 )
	{
		$go_acp_unapproved = append_sid("{$phpbb_root_path}adm/index.$phpEx?i=dm_linkx&amp;mode=release_linkxs", false, true, $user->session_id);

		$template->assign_vars(array(
			'S_DM_NEW_LINKX'	=> true,
			'DM_LINKX_NEW_LINKS_NUMBER'	=> ($linkx_unapproved == 1) ? sprintf($user->lang['DM_LINKX_NEW_LINKX'], $linkx_unapproved) : sprintf($user->lang['DM_LINKX_NEW_LINKXS'], $linkx_unapproved),
			'DM_LINKX_NEW_ACP'	=> sprintf($user->lang['DM_LINKX_ACP'], '<a href="' . $go_acp_unapproved . '">', '</a>'),
		));
	}
	$db->sql_freeresult($result);
}

/**
* Check for reported linkxs
*/
function generate_reported()
{
	global $db, $user, $template, $auth;
	global $phpEx, $phpbb_root_path, $dm_linkx_path, $dm_linkx_config;

	$user->add_lang('mods/dm_linkx');

	$sql = 'SELECT COUNT(linkx_reported) AS linkx_reported
		FROM ' . DM_LINKX_TABLE . '
		WHERE linkx_reported = "1"';
	$result = $db->sql_query($sql);

	$linkx_reported = (int) $db->sql_fetchfield('linkx_reported');

	if ( $linkx_reported > 0 )
	{
		$go_acp_reported = append_sid("{$phpbb_root_path}adm/index.$phpEx?i=dm_linkx&amp;mode=reported_linkxs", false, true, $user->session_id);


		$template->assign_vars(array(
			'S_DM_REPORTED_LINKX'	=> true,
			'DM_LINKX_REPORTED_LINKS_NUMBER'	=> ($linkx_reported == 1) ? sprintf($user->lang['DM_LINKX_REPORTED_LINKX'], $linkx_reported) : sprintf($user->lang['DM_LINKX_REPORTED_LINKXS'], $linkx_reported),
			'DM_LINKX_REPORTED_ACP'	=> sprintf($user->lang['DM_LINKX_ACP'], '<a href="' . $go_acp_reported . '">', '</a>'),
		));
	}
	$db->sql_freeresult($result);
}

/**
* Generate the navigation bar
*/
function generate_cat_nav(&$cat_data)
{
	global $db, $user, $template, $auth;
	global $phpEx, $phpbb_root_path, $dm_linkx_path, $dm_linkx_config;

	$user->add_lang('mods/dm_linkx');

	// Get linkx parents
	$cat_parents = get_cat_parents($cat_data);

	// Build navigation links
	if (!empty($cat_parents))
	{
		foreach ($cat_parents as $parent_cat_id => $parent_data)
		{
			list($parent_name, $parent_type) = array_values($parent_data);
			$template->assign_block_vars('navlinks', array(
				'FORUM_NAME'	=> $parent_name,
				'U_VIEW_FORUM'	=> append_sid("{$phpbb_root_path}{$dm_linkx_path}viewcat.$phpEx", 'c=' . $parent_cat_id),
			));
		}
	}

	$template->assign_block_vars('navlinks', array(
		'FORUM_NAME'	=> $cat_data['cat_name'],
		'U_VIEW_FORUM'	=> append_sid("{$phpbb_root_path}{$dm_linkx_path}viewcat.$phpEx", 'c=' . $cat_data['cat_id']),
	));
	return;
}

/**
* Returns cat parents as an array
*/
function get_cat_parents(&$cat_data)
{
	global $db;

	$cat_parents = array();
	if ($cat_data['parent_id'] > 0)
	{
		if ($cat_data['cat_parents'] == '')
		{
			$sql = 'SELECT cat_id, cat_name
				FROM ' . DM_LINKX_CATS_TABLE . '
				WHERE left_id < ' . $cat_data['left_id'] . '
					AND right_id > ' . $cat_data['right_id'] . '
				ORDER BY left_id ASC';
			$result = $db->sql_query($sql);
			while ($row = $db->sql_fetchrow($result))
			{
				$row['cat_type'] = 1;
				$cat_parents[$row['cat_id']] = array($row['cat_name'], (int) $row['cat_type']);
			}
			$db->sql_freeresult($result);
			$cat_data['cat_parents'] = serialize($cat_parents);
			$sql = 'UPDATE ' . DM_LINKX_CATS_TABLE . "
				SET cat_parents = '" . $db->sql_escape($cat_data['cat_parents']) . "'
				WHERE parent_id = " . $cat_data['parent_id'];
			$db->sql_query($sql);
		}
		else
		{
			$cat_parents = unserialize($cat_data['cat_parents']);
		}
	}
	return $cat_parents;
}

/**
* Get the categories infos
*/
function get_cat_info($cat_id)
{
	global $db;

	$sql = 'SELECT *
		FROM ' . DM_LINKX_CATS_TABLE . '
		WHERE cat_id = ' . $cat_id;
	$result = $db->sql_query($sql);

	while ($row = $db->sql_fetchrow($result))
	{
		$cat_data = $row;
	}
	return $cat_data;
}

/**
* Generate the sub categories list
*/
function generate_cat_list($cat_id)
{
	global $db, $template, $phpbb_root_path, $phpEx, $user, $config, $dm_linkx_path, $dm_linkx_config;

	$sql = 'SELECT bc.*, COUNT(bd.linkx_id) AS number_linkxs, MAX(bd.last_poster_time) AS last_linkx
		FROM ' . DM_LINKX_CATS_TABLE . ' bc
		LEFT JOIN ' . DM_LINKX_CATS_TABLE . ' bc2
			ON ( bc2.left_id < bc.right_id
				AND bc2.left_id > bc.left_id )
		LEFT JOIN ' . DM_LINKX_TABLE . ' bd
			ON ( bd.linkx_cat_id = bc.cat_id
				OR bd.linkx_cat_id = bc2.cat_id )
		WHERE bc.parent_id = ' . $cat_id . '
		GROUP BY bc.cat_id
		ORDER BY bc.left_id ASC';
	$result = $db->sql_query($sql);

	while ($row = $db->sql_fetchrow($result))
	{
		$row['last_linkx'] = ($row['last_linkx']) ? $row['last_linkx'] : 0;
		$subcats = $last_linkx_id = $last_linkx_title = $last_linkx_time = $last_user_id = $last_username = $last_user_colour = $last_poster_full = '';

		// Do we have sub categories?
		if (($row['left_id'] + 1) != $row['right_id'])
		{
			$sql2 = 'SELECT bc.*
				FROM ' . DM_LINKX_CATS_TABLE . ' bc
				WHERE bc.parent_id = ' . $row['cat_id'] . '
				ORDER BY bc.left_id ASC';
			$result2 = $db->sql_query($sql2);

			while ($row2 = $db->sql_fetchrow($result2))
			{
				$subcats .= ($subcats) ? ', ' : '';
				$subcats .= '<a class="subforum ' . (((isset($read_info[$row2['cat_id']]) ? $read_info[$row2['cat_id']] : 0) && ($user->data['user_id'] != ANONYMOUS)) ? 'unread' : 'read') . '" href="';
				$subcats .= append_sid("{$phpbb_root_path}{$dm_linkx_path}viewcat.$phpEx", 'c=' . $row2['cat_id']);
				$subcats .= '">' . censor_text($row2['cat_name']) . '</a>';
			}
			$db->sql_freeresult($result2);

			$folder_image = 'forum_read_subforum';
			$folder_alt = 'no';
			$l_subcats = $user->lang['DM_LINKX_SUB_CAT'];
			if ($row['left_id'] + 3 != $row['right_id'])
			{
				$l_subcats = $user->lang['DM_LINKX_SUB_CATS'];
			}
		}
		else
		{
			$folder_image = 'forum_read';
			$l_subcats = '';
			$folder_alt = 'no';
		}

		// Do we have new linkxs?
		if ($row['last_linkx'] != 0)
		{
			$last_linkx_approval = '';
			$sql2 = 'SELECT bc.*, bd.*, u.username, u.user_id, u.user_colour
				FROM ' . DM_LINKX_CATS_TABLE . ' bc
				LEFT JOIN ' . USERS_TABLE . ' u
					ON u.user_id = bc.linkx_last_poster_id
				LEFT JOIN ' . DM_LINKX_TABLE . ' bd
					ON bc.linkx_last_poster_title = bd.linkx_title
				WHERE bc.linkx_last_linkx_time = ' . $row['last_linkx'] . '
					AND bd.linkx_approval = "1"';
			$result2 = $db->sql_query($sql2);

			while ($row2 = $db->sql_fetchrow($result2))
			{
				$last_linkx_id = $row2['linkx_id'];
				$last_linkx_title = $row2['linkx_title'];
				$last_user_id = $row2['last_poster_id'];
				$last_username = $row2['last_poster_name'];
				$last_user_colour = $row2['last_poster_colour'];
				$last_linkx_time = $row2['last_poster_time'];
				$last_linkx_approval = $row2['linkx_approval'];
			}

			$last_poster_full = $user->lang['POST_BY_AUTHOR'] . ' ' . get_username_string('full', $last_user_id, $last_username, $last_user_colour, $last_username);
			$last_linkx_time = $user->lang['POSTED_ON_DATE'] . ' ' . $user->format_date($last_linkx_time);

			if ( $last_linkx_approval == 0 || empty($last_linkx_title))
			{
				$sql3 = 'SELECT bd.* 
					FROM ' . DM_LINKX_TABLE . ' bd
					WHERE bd.linkx_cat_id = ' . $row['cat_id'] . '
						AND bd.linkx_approval = "1"
					ORDER BY bd.linkx_time DESC';
				$result3 = $db->sql_query_limit($sql3, 1);

				while ($row3 = $db->sql_fetchrow($result3))
				{
					$last_linkx_id = $row3['linkx_id'];
					$last_linkx_title = $row3['linkx_title'];
					$last_user_id = $row3['last_poster_id'];
					$last_username = $row3['last_poster_name'];
					$last_user_colour = $row3['last_poster_colour'];
					$last_linkx_time = $row3['last_poster_time'];
					$last_linkx_approval = $row3['linkx_approval'];
				}   

				if (empty($last_linkx_id))
				{
					$last_linkx_show = '';
				} 
				else 
				{
					$last_poster_full = $user->lang['POST_BY_AUTHOR'] . ' ' . get_username_string('full', $last_user_id, $last_username, $last_user_colour, $last_username);
					$last_linkx_time = $user->lang['POSTED_ON_DATE'] . ' ' . $user->format_date($last_linkx_time);

					if ($last_linkx_approval == 0 || empty($last_linkx_title))
					{
						$last_linkx_title = $user->lang['DM_LINKX_NOT_APPROVED'];
						$last_linkx_show = '';
						$last_poster_full = '';
						$last_linkx_time = '';
					}
					else
					{
						$last_linkx_show = '<a href="' . append_sid("{$phpbb_root_path}{$dm_linkx_path}showlinkx.$phpEx", 'v=' . $last_linkx_id . '&c=' . $row['cat_id']) . '" style="font-weight: bold;" title="' . $last_linkx_title . '">';
					}
				}
				$db->sql_freeresult($result3);
			}
			else
			{
				$last_linkx_show = '<a href="' . append_sid("{$phpbb_root_path}{$dm_linkx_path}showlinkx.$phpEx", 'v=' . $last_linkx_id . '&amp;c=' . $row['cat_id']) . '" style="font-weight: bold;" title="' . $last_linkx_title . '" />';
			}
			$db->sql_freeresult($result2);
		}
		else
		{
			$last_linkx_show = '';
		}

		// Send the results to the template
		$template->assign_block_vars('catrow', array(
			'LAST_LINKX'			=> $row['last_linkx'],
			'DM_LINKX_CAT_NAME'		=> censor_text($row['cat_name']),
			'NUMBER_LINKX'			=> $row['number_linkxs'],
			'U_DM_LINKX_CAT'		=> append_sid("{$phpbb_root_path}{$dm_linkx_path}viewcat.$phpEx", 'c=' . $row['cat_id']),
			'DM_LINKX_CAT_DESC'		=> generate_text_for_display($row['cat_desc'], $row['cat_desc_uid'], $row['cat_desc_bitfield'], $row['cat_desc_options']),
			'LAST_LINKX_TITLE'		=> $last_linkx_title,
			'LAST_POSTER_FULL'		=> $last_poster_full,
			'LAST_LINKX_TIME'		=> $last_linkx_time,
			'U_LAST_LINKX'			=> $last_linkx_show,

			'CAT_FOLDER_IMG_SRC'	=> $user->img($folder_image, $folder_alt, false, '', 'src'),
			'SUBCATS'				=> ($subcats) ? $l_subcats . ': <span style="font-weight: bold;">' . $subcats . '</span>' : '',
		));
	}
	$db->sql_freeresult($result);

	$template->assign_vars(array(
		'LAST_POST_IMG'	=> $user->img('icon_topic_latest', 'VIEW_LATEST_POST'),
	));
}

/**
* Generate xx latest linkxs
*/
function generate_latest_linkxs()
{
	global $db, $template, $phpbb_root_path, $phpEx, $user, $config, $dm_linkx_path, $dm_linkx_config;

	$sql = 'SELECT v.*, u.*
		FROM ' . DM_LINKX_TABLE . ' v
		LEFT JOIN ' . USERS_TABLE . ' u
			ON v.linkx_user_id = u.user_id
		WHERE v.linkx_approval = 1
		ORDER BY v.linkx_time DESC';
	$result = $db->sql_query_limit($sql, $dm_linkx_config['newest_linkxs']);

	while ($row = $db->sql_fetchrow($result))
	{
		$votes 		= $row['linkx_votetotal'];
		$sum 		= $row['linkx_votesum'];
		$avg_score 	= ($row['linkx_votetotal'] == 0) ? 0 : round($row['linkx_votesum'] / $row['linkx_votetotal'], 2);
		$cat_id 	= $row['linkx_cat_id'];

		// Send the results to the template
		$template->assign_block_vars('newest', array(
			'TITLE'				=> $row['linkx_title'],
			'LINKX'				=> $row['linkx_link'],
			'RATING'			=> set_rating_image($votes, $sum, $avg_score),
			'VIEWS'				=> $row['linkx_counter'],
			'POST_AUTHOR_FULL'	=> get_username_string('full', $row['user_id'], $row['username'], $row['user_colour'], $row['username']),
			'POST_TIME'			=> $user->format_date($row['linkx_time']),
			'U_SHOW_LINKX'		=> append_sid("{$phpbb_root_path}{$dm_linkx_path}showlinkx.$phpEx", 'v=' . $row['linkx_id'] . '&amp;c=' . $cat_id),
		));
	}
	$db->sql_freeresult($result);
}

/**
* Generate the linkx list
*/
function generate_linkx_list($cat_id)
{
	global $db, $template, $phpbb_root_path, $phpEx, $user, $config, $dm_linkx_path, $dm_linkx_config;

	$start 		= request_var('start', 0);
	$number 	= $dm_linkx_config['linkx_page_user'];

	$sort_days	= request_var('st', 0);
	$sort_key	= request_var('sk', 'linkx_title');
	$sort_dir	= request_var('sd', 'ASC');
	$limit_days = array(0 => $user->lang['ALL_POSTS'], 1 => $user->lang['1_DAY'], 7 => $user->lang['7_DAYS'], 14 => $user->lang['2_WEEKS'], 30 => $user->lang['1_MONTH'], 90 => $user->lang['3_MONTHS'], 180 => $user->lang['6_MONTHS'], 365 => $user->lang['1_YEAR']);

	$sort_by_text	= array('t' => $user->lang['DM_LINKX_TITLE'], 'u' => $user->lang['DM_LINKX_SORT_FROMNAME'], 'r' => $user->lang['DM_LINKX_SORT_RATING'], 'v' => $user->lang['DM_LINKX_SORT_VIEWS']);
	$sort_by_sql 	= array('t' => 'linkx_title', 'u' => 'linkx_username', 'r' => 'linkx_votesum / linkx_votetotal', 'v' => 'linkx_counter');

	$s_limit_days 	= $s_sort_key = $s_sort_dir = $u_sort_param = '';
	gen_sort_selects($limit_days, $sort_by_text, $sort_days, $sort_key, $sort_dir, $s_limit_days, $s_sort_key, $s_sort_dir, $u_sort_param);
	$sql_sort_order = $sort_by_sql[$sort_key] . ' ' . (($sort_dir == 'd') ? 'DESC' : 'ASC');

	// Total number of linkxs
	$sql = 'SELECT COUNT(linkx_id) AS total_linkxs
		FROM ' . DM_LINKX_TABLE . '
		WHERE linkx_cat_id = ' . $cat_id . '
			AND linkx_approval = "1"
			AND linkx_reported = "0"';
	$result = $db->sql_query($sql);
	$row = $db->sql_fetchrow($result);
	$total_linkxs = $row['total_linkxs'];
	$db->sql_freeresult($result);

	// List all linkxs
	$sql = 'SELECT v.*, u1.user_id, u1.username, u1.user_colour, bc.*
		FROM ' . DM_LINKX_TABLE . ' v
		LEFT JOIN ' . USERS_TABLE . ' u1
			ON u1.user_id = v.linkx_user_id
		LEFT JOIN ' . DM_LINKX_CATS_TABLE . ' bc
			ON bc.cat_id = v.linkx_cat_id
		WHERE v.linkx_cat_id = ' . $cat_id . '
			AND v.linkx_approval = 1
			AND v.linkx_reported = 0
		ORDER BY v.' . $sql_sort_order;
	$result = $db->sql_query_limit($sql, $number, $start);

	while ($row = $db->sql_fetchrow($result))
	{
		$votes = $row['linkx_votetotal'];
		$sum = $row['linkx_votesum'];
		$avg_score = ($row['linkx_votetotal'] == 0) ? 0 : round($row['linkx_votesum'] / $row['linkx_votetotal'], 2);
		$linkx_cat_link = '<a href="' . append_sid("{$phpbb_root_path}{$dm_linkx_path}viewcat.$phpEx", 't=' . $row['linkx_id']) . '"><span style="font-weight: bold;">' . censor_text($row['linkx_title']) . '</span></a>';
		$votes 			= $row['linkx_votetotal'];
		$sum 			= $row['linkx_votesum'];
		$avg_score 		= ($row['linkx_votetotal'] == 0) ? 0 : round($row['linkx_votesum'] / $row['linkx_votetotal'], 2);

		// Send fields to the template
		$template->assign_block_vars('linkxlistrow', array(
			'POST_AUTHOR_FULL'		=> get_username_string('full', $row['user_id'], $row['username'], $row['user_colour'], $row['username']),
			'POST_TIME'				=> $user->format_date($row['linkx_time']),
			'LINKX_ID'				=> $row['linkx_id'],
			'LINKX_TITLE'			=> censor_text($row['linkx_title']),
			'LINKX_LINK'			=> $row['linkx_link'],
			'LINKX_CLICKS'			=> $row['linkx_counter'],
			'LINKX_TIME'			=> $user->format_date($row['linkx_time']),
			'LINKX_RATING_IMG' 		=> set_rating_image($votes, $sum, $avg_score),
			'U_SHOW_LINKX'			=> append_sid("{$phpbb_root_path}{$dm_linkx_path}showlinkx.$phpEx", 'v=' . $row['linkx_id'] . '&amp;c=' . $cat_id),
			'U_LINKX_CAT'			=> $linkx_cat_link,
			'LINKX_CAT'				=> $row['linkx_cat_id'],
		));
	}
	$db->sql_freeresult($result);

	$template->assign_vars(array(
		'S_linkx_ACTION' 	=> append_sid("{$phpbb_root_path}{$dm_linkx_path}viewcat.$phpEx", 'c=' . $cat_id),
		'S_SELECT_SORT_DIR'	=> $s_sort_dir,
		'S_SELECT_SORT_KEY'	=> $s_sort_key,
		'LAST_POST_IMG'		=> $user->img('icon_topic_latest', 'VIEW_LATEST_POST'),
		'PAGINATION' 		=> generate_pagination(append_sid("{$phpbb_root_path}{$dm_linkx_path}viewcat.$phpEx", "c=$cat_id&amp;sk=$sort_key&amp;sd=$sort_dir"), $total_linkxs, $number, $start),
		'PAGE_NUMBER'		=> on_page($total_linkxs, $number, $start),
		'TOTAL_LINKX'		=> ($total_linkxs == 1) ? $user->lang['DM_LINKX_SINGLE'] : sprintf($user->lang['DM_LINKX_MULTI'], $total_linkxs),
	));
}

/**
* Generate rating selection list
*/
function get_rating_select($selected)
{
	global $user;

	$rating_array = array(
		array(
			'value' => 0,
			'text'	=> $user->lang['DM_LINKX_RATING_SELECT'],
		),
		array(
			'value' => 1,
			'text'	=> '1 - ' . $user->lang['DM_LINKX_RATING_BAD'],
		),
		array(
			'value' => 2,
			'text'	=> '2 - ' . $user->lang['DM_LINKX_RATING_NOT_BAD'],
		),
		array(
			'value' => 3,
			'text'	=> '3 - ' . $user->lang['DM_LINKX_RATING_AVG'],
		),
		array(
			'value' => 4,
			'text'	=> '4 - ' . $user->lang['DM_LINKX_RATING_GOOD'],
		),
		array(
			'value' => 5,
			'text'	=> '5 - ' . $user->lang['DM_LINKX_RATING_GREAT'],
		),
	);

	$rating_select = '<select name="linkx_rating" id="linkx_rating">';

	foreach ($rating_array as $option)
	{
		$rating_select .= '<option value="' . $option['value'] . '"' . (($selected == $option['value']) ? ' selected="selected"' : '') . '>' . $option['text'] . '</option>';
	}
	$rating_select .= '</select>';

	return $rating_select;
}

/**
* Set the rating image for the linkx
*/
function set_rating_image($votes, $sum, $avg_score)
{
	global $user;

	$image 				= '';
	$rating_score 		= round($avg_score);
	$rating_score_text 	= $avg_score;

	if ($votes < 1)
	{
		$votes = $user->lang['DM_LINKX_RATING_NO'];
	}
	else
	{
		$votes = ($votes == 1 ) ? sprintf($user->lang['DM_LINKX_RATING_SUM'], $votes, $rating_score) : sprintf($user->lang['DM_LINKX_RATING_SUMS'], $votes, $rating_score_text);
	}

	for ($i = 1; $i <= $rating_score; $i++)
	{
		$image .= '<img src="./../images/dm_linkx/star1.gif" title="' . $votes . '" alt="' . $votes . '" />';
	}

	$blank_stars = ( 5 - $rating_score);
	for ($i = 1; $i <= $blank_stars; $i++)
	{
		$image .= '<img src="./../images/dm_linkx/star2.gif" title="' . $votes . '" alt="' . $votes . '" />';
	}
	return $image;
}

/**
* Create Top xx list by hits
*/
function set_top_10_hits()
{
	global $db, $user, $template, $auth;
	global $phpEx, $phpbb_root_path, $dm_linkx_path, $dm_linkx_config;

	$start 		= request_var('start', 0);

	$sql = 'SELECT v.*, c.cat_name
		FROM ' . DM_LINKX_TABLE . ' v
		LEFT JOIN ' . DM_LINKX_CATS_TABLE .' c
			ON v.linkx_cat_id = c.cat_id
		WHERE v.linkx_counter > 0
		ORDER BY v.linkx_counter DESC';
	$result = $db->sql_query_limit($sql, $dm_linkx_config['top_views']);

	$position = ($start > 0 ) ? $start : 0;
	$actual_position = ($start > 0 ) ? $start : 0;
	$lastscore = 0;

	while ($row = $db->sql_fetchrow($result))
	{
		$actual_position++;
		if ($lastscore != $row['linkx_counter'])
		{
			$position = $actual_position;
		}
		$lastscore = $row['linkx_counter'] ;

		// Create the array for sending to the template
		$template->assign_block_vars('toptenrow', array(
			'POS' 				=> $position,
			'LINKX_TITLE' 		=> $row['linkx_title'],
			'LINKX_link' 		=> $row['linkx_link'],
			'LINKX_CAT_NAME'	=> $row['cat_name'],
			'LINKX_COUNTER'		=> $row['linkx_counter'],
			'U_SHOW_LINKX'		=> append_sid("{$phpbb_root_path}{$dm_linkx_path}showlinkx.$phpEx", 'v=' . $row['linkx_id'] . '&amp;c=' . $row['linkx_cat_id']),
		));
	}
	$db->sql_freeresult($result);

	$template->assign_vars(array(
		'TOPTEN_RATING'			=> sprintf($user->lang['DM_LINKX_RATES'], $dm_linkx_config['top_ratings']),
		'TOPTEN_HITS'			=> sprintf($user->lang['DM_LINKX_HITS'], $dm_linkx_config['top_views']),
		'TOPTEN_HITS_EXPLAIN' 	=> sprintf($user->lang['DM_LINKX_TOPTEN_HITS_EXPLAIN'], $dm_linkx_config['top_views']),
		'U_BACK'		=> append_sid("{$phpbb_root_path}{$dm_linkx_path}index.$phpEx"),
		'U_TOP_RATES'	=> append_sid("{$phpbb_root_path}{$dm_linkx_path}topten.$phpEx?mode=rating")
	));
}

/**
* Create Top 10 list by rating
*/
function set_top_10_rating()
{
	global $db, $user, $template, $auth;
	global $phpEx, $phpbb_root_path, $dm_linkx_path, $dm_linkx_config;

	$start 		= request_var('start', 0);

	$sql = 'SELECT v.*, c.cat_name
		FROM ' . DM_LINKX_TABLE . ' v
		LEFT JOIN ' . DM_LINKX_CATS_TABLE .' c
			ON v.linkx_cat_id = c.cat_id
		WHERE v.linkx_votesum > 0
		ORDER BY v.linkx_votesum/v.linkx_votetotal DESC, v.linkx_votetotal DESC';
	$result = $db->sql_query_limit($sql, $dm_linkx_config['top_ratings']);

	$position 			= ($start > 0 ) ? $start : 0;
	$actual_position 	= ($start > 0 ) ? $start : 0;
	$lastscore 			= 0;

	while ($row = $db->sql_fetchrow($result))
	{
		$votes 		= $row['linkx_votetotal'];
		$sum 		= $row['linkx_votesum'];
		$avg_score 	= ($row['linkx_votetotal'] == 0) ? 0 : ($row['linkx_votesum'] / $row['linkx_votetotal']);

		$actual_position++;

		if ($lastscore != (($row['linkx_votesum'] / $row['linkx_votetotal'])))
		{
			$position = $actual_position;
		}
		$lastscore = (($row['linkx_votesum'] / $row['linkx_votetotal'])) ;

		// Create the array for sending to the template
		$template->assign_block_vars('toptenrow', array(
			'POS' 				=> $position,
			'LINKX_TITLE' 		=> $row['linkx_title'],
			'LINKX_LINK' 		=> $row['linkx_link'],
			'LINKX_CAT_NAME'	=> $row['cat_name'],
			'LINKX_COUNTER'		=> (($row['linkx_votesum'] / $row['linkx_votetotal'])),
			'LINKX_RATING_IMG'	=> set_rating_image($votes, $sum, $avg_score),
			'U_SHOW_LINKX'		=> append_sid("{$phpbb_root_path}{$dm_linkx_path}showlinkx.$phpEx", 'v=' . $row['linkx_id'] . '&amp;c=' . $row['linkx_cat_id']),
		));
	}
	$db->sql_freeresult($result);

	$template->assign_vars(array(
		'TOPTEN_RATING'			=> sprintf($user->lang['DM_LINKX_RATES'], $dm_linkx_config['top_ratings']),
		'TOPTEN_HITS'			=> sprintf($user->lang['DM_LINKX_HITS'], $dm_linkx_config['top_views']),
		'TOPTEN_RATE_EXPLAIN' 	=> sprintf($user->lang['DM_LINKX_TOPTEN_RATE_EXPLAIN'], $dm_linkx_config['top_ratings']),
		'U_BACK'				=> append_sid("{$phpbb_root_path}{$dm_linkx_path}index.$phpEx"),
		'U_TOP_HITS'			=> append_sid("{$phpbb_root_path}{$dm_linkx_path}topten.$phpEx?mode=hits"),
	));
}

/**
* Show comments
*/
function show_comments($show_id)
{
	global $db, $user, $template, $auth;
	global $phpEx, $phpbb_root_path, $dm_linkx_path, $dm_linkx_config;

	$sql = 'SELECT *
		FROM ' . DM_LINKX_COMMENT_TABLE . ' c
		LEFT JOIN ' . USERS_TABLE . ' u
			ON c.user_id = u-user_id
		WHERE linkx_id = ' . $show_id;
	$result = $db->sql_query($sql);

	while ($row = $db->sql_fetchrow($result))
	{
		$comment_text = $row['comment_text'];

		$template->assign_block_vars('comment',array(
		));
	}

	$db->sql_freeresult($result);

	$template->assign_vars(array(
		'U_BACK' => append_sid("{$phpbb_root_path}{$dm_linkx_path}index.$phpEx"),
	));
}

?>