<?php
/**
*
* @package DM Linkx
* @version $Id: index.php 168 2011-12-21 13:54:36Z femu $
* @copyright (c) 2009 femu - http://die-muellers.org
* @license http://opensource.org/licenses/gpl-license.php GNU Public License
*
*/

/**
* @ignore
*/
define('IN_PHPBB', true);
$phpbb_root_path = (defined('PHPBB_ROOT_PATH')) ? PHPBB_ROOT_PATH : '../';
$phpEx = substr(strrchr(__FILE__, '.'), 1);
include($phpbb_root_path . 'common.' . $phpEx);
include($phpbb_root_path . 'includes/message_parser.' . $phpEx);

/**
* Some mod related variables and includes
*/
$dm_linkx_path = (defined('DM_LINKX_ROOT_PATH')) ? DM_LINKX_ROOT_PATH : 'dm_linkx/';
include($phpbb_root_path . $dm_linkx_path . 'common.' . $phpEx);
include($phpbb_root_path . $dm_linkx_path . 'functions_dm_linkx.' . $phpEx);

/**
* Do the session handling
*/
$user->session_begin();
$auth->acl($user->data);
$user->setup('mods/dm_linkx');

/**
* Check authorisation
*/
$is_authorised = ($auth->acl_get('u_dm_linkx_view')) ? true : false;

if (!$is_authorised)
{
	trigger_error('NOT_AUTHORISED');
}

/**
* Check mode
*/
$mode	= request_var('mode', '');

/**
* Create the category list
*/
$cat_id = 0;
generate_cat_list($cat_id);

/**
* Create latest xx linkxs
*/
generate_latest_linkxs();

/**
* Link to call the Top xx
*/
$template->assign_vars(array(
	'TOPTEN_RATING'	=> sprintf($user->lang['DM_LINKX_RATES'], $dm_linkx_config['top_ratings']),
	'TOPTEN_HITS'	=> sprintf($user->lang['DM_LINKX_HITS'], $dm_linkx_config['top_views']),
	'U_TOPTEN_HITS'	=> append_sid("{$phpbb_root_path}{$dm_linkx_path}topten.$phpEx?mode=hits"),
	'U_TOPTEN_RATE'	=> append_sid("{$phpbb_root_path}{$dm_linkx_path}topten.$phpEx?mode=rating"),
	'U_ACTION'	=> append_sid("{$phpbb_root_path}{$dm_linkx_path}searchlinkx.$phpEx"),
));

/**
* The output of the page
*/
page_header($user->lang['DM_LINKX'] . ' &bull; ' . $user->lang['DM_LINKX_INDEX']);

$template->set_filenames(array(
	'body' => $dm_linkx_path . 'index_body.html'
	)
);

page_footer();

?>