<?php
/**
*
* @package DM Linkx
* @version $Id: postcomment.php 168 2011-12-21 13:54:36Z femu $
* @copyright (c) 2009 femu - http://die-muellers.org
* @license http://opensource.org/licenses/gpl-license.php GNU Public License
*
*/

/**
* @ignore
*/
define('IN_PHPBB', true);
$phpbb_root_path = (defined('PHPBB_ROOT_PATH')) ? PHPBB_ROOT_PATH : '../';
$phpEx = substr(strrchr(__FILE__, '.'), 1);
include($phpbb_root_path . 'common.' . $phpEx);
include($phpbb_root_path . 'includes/functions_posting.' . $phpEx);
include($phpbb_root_path . 'includes/functions_display.' . $phpEx);
include($phpbb_root_path . 'includes/message_parser.' . $phpEx);

$dm_linkx_path = (defined('DM_LINKX_ROOT_PATH')) ? DM_LINKX_ROOT_PATH : 'dm_linkx/';
include($phpbb_root_path . $dm_linkx_path . 'common.' . $phpEx);
include($phpbb_root_path . $dm_linkx_path . 'functions_dm_linkx.' . $phpEx);

// Start session management
$user->session_begin();
$auth->acl($user->data);
$user->setup(array('posting', 'mods/dm_linkx'));

/**
* Set some variables
*/
$mode 		= request_var('mode', '');
$cat_id 	= request_var('c', 0);
$linkx_id 	= request_var('v', 0);
$comment_id = request_var('p', 0);
$submit		= (isset($_POST['post'])) ? true : false;
$user_id 	= $user->data['user_id'];

$error 		= '';
$time 		= time();

/**
* Needed switches
*/
switch ($mode)
{
	case 'new':
		$sql = 'SELECT vn.*
			FROM ' . DM_LINKX_CATS_TABLE . ' vn
			WHERE vn.cat_id = ' . $cat_id;
	break;

	case 'delete':
		$sql = 'SELECT vd.*, vc.*, v.*
			FROM ' . DM_LINKX_COMMENT_TABLE . ' vd
			LEFT JOIN ' . DM_LINKX_TABLE . ' v
				ON v.linkx_id = vd.linkx_id
			LEFT JOIN ' . DM_LINKX_CATS_TABLE . ' vc
				ON v.linkx_cat_id = vc.cat_id
			WHERE vd.comment_id = ' . $comment_id;
	break;

	case 'edit';
		$sql = 'SELECT vd.*, vc.*, v.*
			FROM ' . DM_LINKX_COMMENT_TABLE . ' vd
			LEFT JOIN ' . DM_LINKX_TABLE . ' v
				ON v.linkx_id = vd.linkx_id
			LEFT JOIN ' . DM_LINKX_CATS_TABLE . ' vc
				ON v.linkx_cat_id = vc.cat_id
			WHERE vd.comment_id = ' . $comment_id;

	break;

	default:
	break;
}
$result = $db->sql_query($sql);
$cat_data = $db->sql_fetchrow($result);
$db->sql_freeresult($result);
$linkx_cat_name = $cat_data['cat_name'];
$linkx_parent_cat_id = $cat_data['parent_id'];
$show_cat_id = $cat_data['cat_id'];

/**
* redirect unauthorized ones
*/
if ($user->data['is_bot'])
{
	switch ($mode)
	{
		default:
			redirect(append_sid("{$phpbb_root_path}{$dm_linkx_path}index.$phpEx"));
		break;
	}
}

/**
* Generate the navigation
*/
generate_cat_nav($cat_data);

/**
* Main working switches here
*/
switch ($mode)
{
	case 'new':
		add_form_key('dm_linkx');

		if (!$auth->acl_get('u_dm_linkx_comment_add', 'a_dm_linkx_manage'))
		{
			trigger_error('NOT_AUTHORISED');
		}

		if($submit)
		{
			if (!check_form_key('dm_linkx'))
			{
				trigger_error($user->lang['FORM_INVALID']);
			}

			$data['message']			= utf8_normalize_nfc(request_var('message', '', true));
			$data['bbcode_checked']		= (isset($_POST['disable_bbcode'])) ? false : true;
			$data['smilies_checked']	= (isset($_POST['disable_smilies'])) ? false : true;
			$data['urls_checked']		= (isset($_POST['disable_magic_url'])) ? false : true;
			$data['linkx_user_id']		= $user->data['user_id'];
			$data['linkx_user_name']	= $user->data['username'];
			$data['linkx_user_colour']	= $user->data['user_colour'];

			$back_link = append_sid("{$phpbb_root_path}{$dm_linkx_path}postcomment.$phpEx", 'mode=new&amp;c=' . $cat_id . '&amp;v=' . $linkx_id);

			if(empty($data['message']))
			{
				trigger_error($user->lang['DM_LINKX_COMMENT_NEEDED'] . sprintf($user->lang['DM_LINKX_BACK_LINK3'],'<a href="' . $back_link . '">', '</a>'));
			}

			$uid = $bitfield = $options = ''; // will be modified by generate_text_for_storage
			generate_text_for_storage($data['message'], $uid, $bitfield, $options, $data['bbcode_checked'], $data['urls_checked'], $data['smilies_checked']);

			// Create array for linkx comment
			$sql_ary = array(
				'linkx_id'					=> $linkx_id,
				'linkx_user_id'				=> $user->data['user_id'],
				'linkx_username'			=> $user->data['username'],
				'linkx_user_colour'			=> $user->data['user_colour'],
				'linkx_time'				=> $time,
				'linkx_comment'				=> $data['message'],
				'enable_bbcode' 			=> $data['bbcode_checked'],
				'enable_smilies' 			=> $data['smilies_checked'],
				'enable_magic_url'			=> $data['urls_checked'],
				'comment_bbcode_bitfield'	=> $bitfield,
				'comment_bbcode_uid'		=> $uid,
				'comment_bbcode_options'	=> $options,
			);


			$db->sql_query('INSERT INTO ' . DM_LINKX_COMMENT_TABLE . ' ' . $db->sql_build_array('INSERT', $sql_ary));

			$redirect_url = append_sid("{$phpbb_root_path}{$dm_linkx_path}showcomments.$phpEx", 'v=' . $linkx_id . '&amp;c=' . $cat_id);
			trigger_error($user->lang['DM_LINKX_COMMENT_ADDED'] . sprintf($user->lang['DM_LINKX_BACK_LINK_COMMENT'],'<a href="' . $redirect_url . '">', '</a>'));
		}

		$template->assign_vars(array(
			'LINKX_COMMENT'				=> request_var('message', '', true),

			'L_POST_A' 					=> ($mode == 'edit') ? $user->lang['DM_LINKX_COMMENT_EDIT'] : $user->lang['DM_LINKX_COMMENT_ADD'],

			'S_EDIT_MODE'				=> ($mode == 'edit') ? true : false,
			'S_FORM_ENCTYPE'			=> ' enctype="multipart/form-data"',
			'S_BBCODE_ALLOWED'			=> $user->optionget('bbcode'),
			'S_BBCODE_IMG'				=> $user->optionget('bbcode'),
			'S_LINKS_ALLOWED'			=> $user->optionget('bbcode'),
			'S_BBCODE_URL'				=> $user->optionget('bbcode'),
			'S_BBCODE_FLASH'			=> $user->optionget('bbcode'),
			'S_BBCODE_QUOTE'			=> true,
			'S_FORM_TOKEN'				=> true,
			'LINKX_ID'					=> $linkx_id,
			'BBCODE_STATUS'				=> sprintf($user->lang['BBCODE_IS_ON'], '<a href="' . append_sid("{$phpbb_root_path}faq.$phpEx", 'mode=bbcode') . '">', '</a>'),
		));
	break;

	case 'edit':
		add_form_key('dm_linkx');

		$linkx_user_id 	= $cat_data['linkx_user_id'];
		decode_message($cat_data['linkx_comment'], $cat_data['comment_bbcode_uid']);
		$post_message 	= $cat_data['linkx_comment'];

		if ($submit)
		{
			if (!check_form_key('dm_linkx'))
			{
				trigger_error($user->lang['FORM_INVALID']);
			}

			$data['message']			= utf8_normalize_nfc(request_var('message', '', true));
			$data['bbcode_checked']		= $cat_data['enable_bbcode'];
			$data['smilies_checked']	= $cat_data['enable_smilies'];
			$data['urls_checked']		= $cat_data['enable_magic_url'];

			if ($linkx_user_id != $user->data['user_id'])
			{
				$redirect_url = append_sid("{$phpbb_root_path}{$dm_linkx_path}viewcat.$phpEx", 'c=' . $data['linkx_cat_id']);
				trigger_error($user->lang['NOT_AUTHORISED'] . sprintf($user->lang['DM_LINKX_BACK_LINK'],'<a href="' . $redirect_url . '">', '</a>'));
			}

			$uid = $bitfield = $options = ''; // will be modified by generate_text_for_storage
			generate_text_for_storage($data['message'], $uid, $bitfield, $options, $data['bbcode_checked'], $data['urls_checked'], $data['smilies_checked']);

			// Create array for linkx comment
			$sql_edit_ary = array(
				'linkx_comment'				=> $data['message'],
				'enable_bbcode' 			=> $data['bbcode_checked'],
				'enable_smilies' 			=> $data['smilies_checked'],
				'enable_magic_url'			=> $data['urls_checked'],
				'comment_bbcode_bitfield'	=> $bitfield,
				'comment_bbcode_uid'		=> $uid,
				'comment_bbcode_options' 	=> $options,
			);

			$db->sql_query('UPDATE ' . DM_LINKX_COMMENT_TABLE . ' SET ' . $db->sql_build_array('UPDATE', $sql_edit_ary) . ' WHERE comment_id = ' . $comment_id);

			$redirect_url = append_sid("{$phpbb_root_path}{$dm_linkx_path}showcomments.$phpEx", 'v=' . $cat_data['linkx_id'] . '&amp;c=' . $cat_data['cat_id']);
			trigger_error($user->lang['DM_LINKX_COMMENT_EDITED'] . sprintf($user->lang['DM_LINKX_BACK_LINK_COMMENT'],'<a href="' . $redirect_url . '">', '</a>'));
		}

		$template->assign_vars(array(
			'LINKX_COMMENT'		=> $post_message,

			'L_POST_A' 			=> ($mode == 'edit') ? $user->lang['DM_LINKX_COMMENT_EDIT'] : $user->lang['DM_LINKX_COMMENT_NEW'],

			'S_FORM_ENCTYPE'	=> ' enctype="multipart/form-data"',
			'S_BBCODE_ALLOWED'	=> $user->optionget('bbcode'),
			'S_BBCODE_IMG'		=> $user->optionget('bbcode'),
			'S_LINKS_ALLOWED'	=> $user->optionget('bbcode'),
			'S_BBCODE_URL'		=> $user->optionget('bbcode'),
			'S_BBCODE_FLASH'	=> $user->optionget('bbcode'),
			'S_BBCODE_QUOTE'	=> true,
			'S_FORM_TOKEN'		=> true,
			'LINKX_ID'			=> $linkx_id,
			'BBCODE_STATUS'		=> sprintf($user->lang['BBCODE_IS_ON'], '<a href="' . append_sid("{$phpbb_root_path}faq.$phpEx", 'mode=bbcode') . '">', '</a>'),
		));
	break;

	case 'delete':
		$show_linkx_id = $cat_data['linkx_id'];

		if (!$auth->acl_get('u_dm_linkx_comment_del', 'a_dm_linkx_manage'))
		{
			trigger_error('NOT_AUTHORISED');
		}

		$s_hidden_fields = build_hidden_fields(array(
			'p'		=> $comment_id,
			'mode'	=> 'delete')
		);

		if (confirm_box(true))
		{
		$sql = 'DELETE FROM ' . DM_LINKX_COMMENT_TABLE . ' WHERE comment_id = ' . $comment_id;
		$db->sql_query($sql);
		$cache->destroy('sql', DM_LINKX_COMMENT_TABLE);

		$redirect_url = append_sid("{$phpbb_root_path}{$dm_linkx_path}index.$phpEx");
		meta_refresh(3, $redirect_url);
		trigger_error($user->lang['DM_LINKX_COMMENT_DELETED'] . '<br /><br />' . sprintf($user->lang['DM_LINKX_BACK_LINKX'],'<a href="' . $redirect_url . '">', '</a>'));
		}
		else
		{
			if (isset($_POST['cancel']))
			{
				redirect(append_sid("{$phpbb_root_path}{$dm_linkx_path}showcomments.$phpEx", 'v=' . $show_linkx_id . '&amp;c=' . $show_cat_id));
			}
			else
			{
				confirm_box(false, 'DM_LINKX_COMMENT_DEL', $s_hidden_fields);
			}
		}
	break;

	default:
	break;
}

// Build custom bbcodes array
display_custom_bbcodes();
if($user->optionget('smilies'))
{
	generate_smilies('inline', 1);
}

add_form_key('dm_linkx');

// Output page
page_header(($mode == 'edit') ? $user->lang['DM_LINKX_EDIT_LINKX'] : $user->lang['DM_LINKX_ADD_LINKX']);

/**
* The output of the page
*/
$action = ($mode == 'new') ? $user->lang['DM_LINKX_COMMENT_NEW'] : $user->lang['DM_LINKX_COMMENT_EDIT'];

page_header($user->lang['DM_LINKX_LINKX'] . ' &bull; ' . $action);

$template->set_filenames(array(
	'body' => $dm_linkx_path . 'postcomment_body.html')
);

page_footer();

?>