<?php
/**
*
* @package DM Linkx
* @version $Id: postlinkx.php 168 2011-12-21 13:54:36Z femu $
* @copyright (c) 2008, 2009 Die Muellers http://die-muellers.org
* @license http://opensource.org/licenses/gpl-license.php GNU Public License
*
*/

/**
* @ignore
*/
define('IN_PHPBB', true);
$phpbb_root_path = (defined('PHPBB_ROOT_PATH')) ? PHPBB_ROOT_PATH : '../';
$phpEx = substr(strrchr(__FILE__, '.'), 1);
include($phpbb_root_path . 'common.' . $phpEx);
include($phpbb_root_path . 'includes/functions_posting.' . $phpEx);
include($phpbb_root_path . 'includes/functions_display.' . $phpEx);
include($phpbb_root_path . 'includes/message_parser.' . $phpEx);

$dm_linkx_path = (defined('DM_LINKX_ROOT_PATH')) ? DM_LINKX_ROOT_PATH : 'dm_linkx/';
include($phpbb_root_path . $dm_linkx_path . 'common.' . $phpEx);
include($phpbb_root_path . $dm_linkx_path . 'functions_dm_linkx.' . $phpEx);

// Start session management
$user->session_begin();
$auth->acl($user->data);
$user->setup(array('posting', 'mods/dm_linkx'));

/**
* Set some variables
*/
$mode = request_var('mode', '');
$cat_id = request_var('c', 0);
$linkx_id = request_var('v', 0);
$submit	= (isset($_POST['post'])) ? true : false;
$user_id = $user->data['user_id'];

$error = '';
$time = time();

/**
* Needed switches
*/
switch ($mode)
{
	case 'new':
		$sql = 'SELECT *
			FROM ' . DM_LINKX_CATS_TABLE . '
			WHERE cat_id = ' . $cat_id;
	break;
	
	case 'edit';
		$sql = 'SELECT vc.*, v.*
			FROM ' . DM_LINKX_TABLE . ' v
			LEFT JOIN ' . DM_LINKX_CATS_TABLE . ' vc
				ON v.linkx_cat_id = vc.cat_id				
			WHERE v.linkx_id = ' . $linkx_id;
	break;
	
	case 'delete':
		$sql = 'SELECT vd.*, vc.*, v.*
			FROM ' . DM_LINKX_COMMENT_TABLE . ' vd
			LEFT JOIN ' . DM_LINKX_TABLE . ' v
				ON v.linkx_id = vd.linkx_id
			LEFT JOIN ' . DM_LINKX_CATS_TABLE . ' vc
				ON v.linkx_cat_id = vc.cat_id				
			WHERE v.linkx_id = ' . $linkx_id;
	break;
	
	default:
	break;
}
$result = $db->sql_query($sql);
$cat_data = $db->sql_fetchrow($result);
$db->sql_freeresult($result);
$linkx_cat_name = $cat_data['cat_name'];
$linkx_parent_cat_id = $cat_data['parent_id'];
$show_cat_id = $cat_data['cat_id'];

/**
* redirect unauthorized ones
*/
if ($user->data['is_bot'])
{
	switch ($mode)
	{
		default:
			redirect(append_sid("{$phpbb_root_path}{$dm_linkx_path}index.$phpEx"));
		break;
	}
}

/**
* Generate the navigation
*/
generate_cat_nav($cat_data);

/**
* Main working switches here
*/
switch ($mode)
{
	case 'new':
		add_form_key('dm_linkx');

		if (!$auth->acl_get('u_dm_linkx_add', 'a_dm_linkx_manage'))
		{
			trigger_error('NOT_AUTHORISED');
		}
		
		if($submit)
		{
			if (!check_form_key('dm_linkx'))
			{
				trigger_error($user->lang['FORM_INVALID']);
			}

			$data['linkx_title']		= utf8_normalize_nfc(request_var('linkx_title', '', true));
			$data['linkx_link']			= utf8_normalize_nfc(request_var('linkx_link', '', true));
			$data['linkx_image'] 		= utf8_normalize_nfc(request_var('linkx_image', '', true));
			$data['message']			= utf8_normalize_nfc(request_var('message', '', true));
			$data['linkx_cat_id']		= $cat_id;
			$data['bbcode_checked']		= (isset($_POST['disable_bbcode'])) ? false : true;
			$data['smilies_checked']	= (isset($_POST['disable_smilies'])) ? false : true;
			$data['urls_checked']		= (isset($_POST['disable_magic_url'])) ? false : true;
			$data['linkx_user_id']		= $user->data['user_id'];
			$data['linkx_user_name']	= $user->data['username'];
			$data['linkx_user_colour']	= $user->data['user_colour'];

			$back_link = append_sid("{$phpbb_root_path}{$dm_linkx_path}postlinkx.$phpEx", 'mode=new&amp;c=' . $cat_id);

			if ($user->data['user_type'] == 3)
			{
				$linkx_approval	= 1;
			}
			else
			{
				$linkx_approval = 0;
			}
			
			if (empty($data['linkx_title']) || empty($data['linkx_link']))
			{
				trigger_error($user->lang['DM_LINKX_NEED_DATA'] . sprintf($user->lang['DM_LINKX_BACK_LINK3'],'<a href="' . $back_link . '">', '</a>'));
			}

			$uid = $bitfield = $options = ''; // will be modified by generate_text_for_storage
			generate_text_for_storage($data['message'], $uid, $bitfield, $options, $data['bbcode_checked'], $data['urls_checked'], $data['smilies_checked']);

			// Create array for linkx 
			$sql_ary = array(
				'linkx_title'			=> $data['linkx_title'],
				'linkx_desc'			=> $data['message'],
				'linkx_link'			=> $data['linkx_link'],
				'linkx_image'			=> $data['linkx_image'],
				'linkx_approval'		=> $linkx_approval,
				'linkx_user_id'			=> $user->data['user_id'],
				'linkx_username'		=> $user->data['username'],
				'linkx_time'			=> $time,
				'linkx_cat_id'			=> $data['linkx_cat_id'],
				'last_poster_id'		=> $user->data['user_id'],
				'last_poster_name'		=> $user->data['username'],
				'last_poster_colour'	=> $user->data['user_colour'],
				'last_poster_time'		=> $time,
				'last_poster_cat_id'	=> $data['linkx_cat_id'],
				'enable_bbcode' 		=> $data['bbcode_checked'],
				'enable_smilies' 		=> $data['smilies_checked'],
				'enable_magic_url'		=> $data['urls_checked'],
				'bbcode_bitfield'		=> $bitfield,
				'bbcode_uid'			=> $uid,
				'bbcode_options'		=> $options,
			);

			// Create SQL Array for cats
			$cat_ary = array(
				'linkx_last_poster_title'	=> $data['linkx_title'],
				'linkx_last_poster_id'		=> $user->data['user_id'],
				'linkx_last_poster_name'	=> $user->data['username'],
				'linkx_last_poster_colour'	=> $user->data['user_colour'],
				'linkx_last_linkx_time' 	=> $time,
			);

			$db->sql_query('INSERT INTO ' . DM_LINKX_TABLE . ' ' . $db->sql_build_array('INSERT', $sql_ary));

			$db->sql_query('UPDATE ' . DM_LINKX_CATS_TABLE . ' SET ' . $db->sql_build_array('UPDATE', $cat_ary) . ' WHERE cat_id = ' . $data['linkx_cat_id']);

			$redirect_url = append_sid("{$phpbb_root_path}{$dm_linkx_path}viewcat.$phpEx", 'c=' . $data['linkx_cat_id']);
			if ( $user->data['user_type'] == 3)
			{
				trigger_error(sprintf($user->lang['DM_LINKX_ADMIN_ADDED'] . $user->lang['DM_LINKX_BACK_LINK'],'<a href="' . $redirect_url . '">', '</a>'));
			}
			else
			{
				trigger_error($user->lang['DM_LINKX_ADDED'] . sprintf($user->lang['DM_LINKX_BACK_LINK'],'<a href="' . $redirect_url . '">', '</a>'));
			}
		}

		// Start assigning vars for main posting page ...
		$template->assign_vars(array(
			'LINKX_TITLE'				=> request_var('linkx_title', '', true),
			'LINKX_LINK'				=> request_var('linkx_link', '', true),
			'LINKX_DESC'				=> request_var('message', '', true),
			'LINKX_IMAGE'				=> request_var('linkx_image', '', true),

			'L_POST_A' 					=> ($mode == 'edit') ? $user->lang['DM_LINKX_EDIT_LINKX'] : $user->lang['DM_LINKX_ADD_LINKX'],

			'S_EDIT_MODE'				=> ($mode == 'edit') ? true : false,
			'S_EDIT'					=> ($mode == 'edit') ? true : false,
			'S_FORM_ENCTYPE'			=> ' enctype="multipart/form-data"',
			'S_BBCODE_ALLOWED'			=> $user->optionget('bbcode'),
			'S_BBCODE_IMG'				=> $user->optionget('bbcode'),
			'S_LINKS_ALLOWED'			=> $user->optionget('bbcode'),
			'S_BBCODE_URL'				=> $user->optionget('bbcode'),
			'S_BBCODE_FLASH'			=> $user->optionget('bbcode'),
			'S_BBCODE_QUOTE'			=> true,
			
			'CAT_ID'					=> $cat_id,
			'BBCODE_STATUS'				=> sprintf($user->lang['BBCODE_IS_ON'], '<a href="' . append_sid("{$phpbb_root_path}faq.$phpEx", 'mode=bbcode') . '">', '</a>'),
		));
	break;

	case 'edit':
		decode_message($cat_data['linkx_desc'], $cat_data['bbcode_uid']);
		$post_message 	= $cat_data['linkx_desc'];

		add_form_key('dm_linkx');

		if (!$auth->acl_get('u_dm_linkx_add', 'a_dm_linkx_manage', 'u_dm_linkx_edit'))
		{
			trigger_error('NOT_AUTHORISED');
		}
		
		if($submit)
		{
			if (!check_form_key('dm_linkx'))
			{
				trigger_error($user->lang['FORM_INVALID']);
			}

			$data['message']			= utf8_normalize_nfc(request_var('message', '', true));
			$data['linkx_title'] 		= request_var('linkx_title', '', true);
			$data['linkx_link']			= request_var('linkx_link', '', true);
			$data['linkx_image']		= request_var('linkx_image', '', true);
			$data['bbcode_checked']		= $cat_data['enable_bbcode'];
			$data['smilies_checked']	= $cat_data['enable_smilies'];
			$data['urls_checked']		= $cat_data['enable_magic_url'];

			$uid = $bitfield = $options = ''; // will be modified by generate_text_for_storage
			generate_text_for_storage($data['message'], $uid, $bitfield, $options, $data['bbcode_checked'], $data['urls_checked'], $data['smilies_checked']);

			// Create SQL array for editing
			$sql_edit_ary = array(
				'linkx_title'			=> $data['linkx_title'],
				'linkx_desc'			=> $data['message'],
				'linkx_link'			=> $data['linkx_link'],
				'linkx_image'			=> $data['linkx_image'],
				'enable_bbcode' 		=> $data['bbcode_checked'],
				'enable_smilies' 		=> $data['smilies_checked'],
				'enable_magic_url'		=> $data['urls_checked'],
				'bbcode_bitfield'		=> $bitfield,
				'bbcode_uid'			=> $uid,
				'bbcode_options' 		=> $options,
			);

			$db->sql_query('UPDATE ' . DM_LINKX_TABLE . ' SET ' . $db->sql_build_array('UPDATE', $sql_edit_ary) . ' WHERE linkx_id = ' . $linkx_id);

			$cache->destroy('sql', DM_LINKX_TABLE);

			$redirect_url = append_sid("{$phpbb_root_path}{$dm_linkx_path}viewcat.$phpEx", 'c=' . $cat_id);
			trigger_error($user->lang['DM_LINKX_EDITED'] . sprintf($user->lang['DM_LINKX_BACK_LINK'],'<a href="' . $redirect_url . '">', '</a>'));
		}

		// Start assigning vars for main posting page ...
		$template->assign_vars(array(
			'LINKX_TITLE'		=> $cat_data['linkx_title'], //$data['linkx_title'],
			'LINKX_LINK'		=> $cat_data['linkx_link'], //$data['linkx_singer'],
			'LINKX_DESC'		=> $post_message,
			'LINKX_IMAGE'		=> $cat_data['linkx_image'], //$data['linkx_image'],

			'L_POST_A' 					=> ($mode == 'edit') ? $user->lang['DM_LINKX_EDIT_LINKX'] : $user->lang['DM_LINKX_ADD_LINKX'],

			'S_EDIT_MODE'				=> ($mode == 'edit') ? true : false,
			'S_EDIT'					=> ($mode == 'edit') ? true : false,
			'S_FORM_ENCTYPE'			=> ' enctype="multipart/form-data"',
			'S_BBCODE_ALLOWED'			=> $user->optionget('bbcode'),
			'S_BBCODE_IMG'				=> $user->optionget('bbcode'),
			'S_LINKS_ALLOWED'			=> $user->optionget('bbcode'),
			'S_BBCODE_URL'				=> $user->optionget('bbcode'),
			'S_BBCODE_FLASH'			=> $user->optionget('bbcode'),
			'S_BBCODE_QUOTE'			=> true,
			
			'CAT_ID'					=> $cat_id,
			'BBCODE_STATUS'				=> sprintf($user->lang['BBCODE_IS_ON'], '<a href="' . append_sid("{$phpbb_root_path}faq.$phpEx", 'mode=bbcode') . '">', '</a>'),
		));
	break;
	
	case 'delete':
		if (!$auth->acl_get('u_dm_linkx_del', 'a_dm_linkx_manage'))
		{
			trigger_error('NOT_AUTHORISED');
		}

		$s_hidden_fields = build_hidden_fields(array(
			'p'		=> $linkx_id,
			'mode'	=> 'delete')
		);

		if (confirm_box(true))
		{
			$sql = 'DELETE FROM ' . DM_LINKX_TABLE . ' WHERE linkx_id = ' . $linkx_id;
			$db->sql_query($sql);
			$cache->destroy('sql', DM_LINKX_TABLE);
			
			$sql = 'DELETE FROM ' . DM_LINKX_COMMENT_TABLE . ' WHERE linkx_id = ' . $linkx_id;
			$db->sql_query($sql);
			$cache->destroy('sql', DM_LINKX_COMMENT_TABLE);

			$redirect_url = append_sid("{$phpbb_root_path}{$dm_linkx_path}index.$phpEx");
			meta_refresh(3, $redirect_url);
			trigger_error($user->lang['DM_LINKX_DELETED_LINKX'] . '<br /><br />' . sprintf($user->lang['DM_LINKX_BACK_LINKX'],'<a href="' . $redirect_url . '">', '</a>'));
		}
		else
		{
			if (isset($_POST['cancel']))
			{
				redirect(append_sid("{$phpbb_root_path}{$dm_linkx_path}showlinkx.$phpEx", 'v=' . $linkx_id . '&amp;c=' . $cat_id));
			}
			else
			{
				confirm_box(false, 'DM_LINKX_DELETE_LINKX', $s_hidden_fields);
			}
		}
	break;
	
	default:
	break;
}

// Build custom bbcodes array
display_custom_bbcodes();
if($user->optionget('smilies'))
{
	generate_smilies('inline', 1);
}

add_form_key('dm_linkx');

// Output page
page_header(($mode == 'edit') ? $user->lang['DM_LINKX_EDIT_LINKX'] : $user->lang['DM_LINKX_ADD_LINKX']);


/**
* The output of the page
*/
page_header($user->lang['DM_LINKX_LINKX'] . ' &bull; ' . $user->lang['DM_LINKX_INDEX']);

$template->set_filenames(array(
	'body' => $dm_linkx_path . 'postlinkx_body.html')
);

page_footer();

?>