<?php
/**
*
* @package DM Linkx
* @version $Id: showcomments.php 168 2011-12-21 13:54:36Z femu $
* @copyright (c) 2009 femu - http://die-muellers.org
* @license http://opensource.org/licenses/gpl-license.php GNU Public License
*
*/

/**
* @ignore
*/
define('IN_PHPBB', true);
$phpbb_root_path = (defined('PHPBB_ROOT_PATH')) ? PHPBB_ROOT_PATH : '../';
$phpEx = substr(strrchr(__FILE__, '.'), 1);
include($phpbb_root_path . 'common.' . $phpEx);
include($phpbb_root_path . 'includes/functions_display.' . $phpEx);
include($phpbb_root_path . 'includes/bbcode.' . $phpEx);
include($phpbb_root_path . 'includes/message_parser.' . $phpEx);

/**
* Some mod related variables and includes
*/
$dm_linkx_path = (defined('DM_LINKX_ROOT_PATH')) ? DM_LINKX_ROOT_PATH : 'dm_linkx/';
include($phpbb_root_path . $dm_linkx_path . 'common.' . $phpEx);
include($phpbb_root_path . $dm_linkx_path . 'functions_dm_linkx.' . $phpEx);

/**
* Do the session handling
*/
$user->session_begin();
$auth->acl($user->data);
$user->setup(array('viewtopic', 'viewforum', 'mods/dm_linkx'));

/**
* Set some variables
*/
$linkx_id = request_var('v', 0);
$cat_id  = request_var('c', 0);
$start 	 = request_var('start', 0);
$number  = $dm_linkx_config['linkx_page_comment'];

/**
* We need som informations about the category we are in for the navigation
*/
$cat_data = get_cat_info($cat_id);

/**
* Generate the navigation
*/
generate_cat_nav($cat_data);

/**
* Generate the sub categories
*/
generate_cat_list($cat_id);

/**
* Select the needed data to show the comments
*/

// Selecting the total number of comments
$sql = 'SELECT COUNT(comment_id) AS total_comments
	FROM ' . DM_LINKX_COMMENT_TABLE . '
	WHERE linkx_id = ' . $linkx_id;
$result = $db->sql_query($sql);
$row = $db->sql_fetchrow($result);
$total_comments = $row['total_comments'];
$db->sql_freeresult($result);

// Selecting the name of linkx for the title
$sql = 'SELECT linkx_title
	FROM ' . DM_LINKX_TABLE . '
	WHERE linkx_id = ' . $linkx_id;
$result = $db->sql_query($sql);
$row = $db->sql_fetchrow($result);
$linkx_title = $row['linkx_title'];
$db->sql_freeresult($result);

// Selecting the needed fields from the comment and users table
// and send the values as the comment rows with pagination
$sql = 'SELECT c.*, u.username, u.user_id, u.user_colour
	FROM ' . DM_LINKX_COMMENT_TABLE . ' c
	LEFT JOIN ' . USERS_TABLE . ' u
		ON c.linkx_user_id = u.user_id
	WHERE c.linkx_id = ' . $linkx_id .' 
	ORDER BY c.comment_id DESC';
// Following limit is need to set the pagination!!
$result = $db->sql_query_limit($sql, $number, $start);

while ($row = $db->sql_fetchrow($result))
{
	$linkx_comment = generate_text_for_display($row['linkx_comment'], $row['comment_bbcode_uid'], $row['comment_bbcode_bitfield'], $row['comment_bbcode_options']);
	$linkx_comment_id	= $row['comment_id'];
	$linkx_username		= $row['linkx_username'];
	$linkx_user_colour	= $row['linkx_user_colour'];
	$linkx_time			= $row['linkx_time'];

	$template->assign_block_vars('comments',array(
		'LINKX_COMMENT'			=> $linkx_comment,

		'S_EDIT_COMMENT'		=> (($auth->acl_get('u_dm_linkx_comment_edit') && $row['linkx_user_id'] == $user->data['user_id']) || $auth->acl_get('a_dm_linkx_comment_edit')),
		'S_DELETE_COMMENT'		=> (($auth->acl_get('u_dm_linkx_comment_del') && $row['linkx_user_id'] == $user->data['user_id']) || $auth->acl_get('a_dm_linkx_comment_del')),

		'COMMENT_AUTHOR_FULL'	=> get_username_string('full', $row['user_id'], $row['username'], $row['user_colour'], $row['username']),
		'COMMENT_POST_TIME'		=> $user->format_date($row['linkx_time']),

		'U_EDIT_COMMENT'		=> append_sid("{$phpbb_root_path}{$dm_linkx_path}postcomment.$phpEx", 'mode=edit&amp;p=' . $linkx_comment_id),
		'U_DELETE_COMMENT'		=> append_sid("{$phpbb_root_path}{$dm_linkx_path}postcomment.$phpEx", 'mode=delete&amp;p=' . $linkx_comment_id),
	));
}
//$db->sql_freeresult($result);

/**
* Send the stuff to the template
*/
$template->assign_vars(array(
	'LINKX_NAME'			=> $linkx_title,
	'LINKX_TITLE' 			=> sprintf($user->lang['DM_LINKX_COMMENT_SHOW'], $linkx_title),

	'EDIT_IMG' 				=> $user->img('icon_post_edit', 'EDIT_POST'),
	'DELETE_IMG' 			=> $user->img('icon_post_delete', 'DELETE_POST'),

	'S_ADD_COMMENT'			=> $auth->acl_get('u_dm_linkx_comment_add'),

	'U_ADD_COMMENT'			=> append_sid("{$phpbb_root_path}{$dm_linkx_path}postcomment.$phpEx", 'mode=new&amp;c=' . $cat_id . '&amp;v=' . $linkx_id),
	'U_BACK_CAT'			=> append_sid("{$phpbb_root_path}{$dm_linkx_path}viewcat.$phpEx", 'c=' . $cat_id),
	'U_BACK_LINKX'			=> append_sid("{$phpbb_root_path}{$dm_linkx_path}showlinkx.$phpEx", 'v=' . $linkx_id . '&amp;c=' . $cat_id),
	
	'PAGINATION' 			=> generate_pagination(append_sid("{$phpbb_root_path}{$dm_linkx_path}showcomments.$phpEx", "v=$linkx_id&amp;c=$cat_id"), $total_comments, $number, $start),
	'PAGE_NUMBER'			=> on_page($total_comments, $number, $start),
	'TOTAL_COMMENTS'		=> ($total_comments == 1) ? $user->lang['DM_LINKX_COMMENT_SINGLE'] : sprintf($user->lang['DM_LINKX_COMMENT_MULTI'], $total_comments),
	)
);

/**
* The output of the page
*/
page_header($user->lang['DM_LINKX_LINKX'] . ' &bull; ' . $user->lang['DM_LINKX_COMMENT']);

$template->set_filenames(array(
   'body' => $dm_linkx_path . 'showcomments_body.html'
   )
);

page_footer();

?>