<?php
/**
*
* @package DM Linkx
* @version $Id: showlinkx.php 168 2011-12-21 13:54:36Z femu $
* @copyright (c) 2009 femu - http://die-muellers.org
* @license http://opensource.org/licenses/gpl-license.php GNU Public License
*
*/

/**
* @ignore
*/
define('IN_PHPBB', true);
$phpbb_root_path = (defined('PHPBB_ROOT_PATH')) ? PHPBB_ROOT_PATH : '../';
$phpEx = substr(strrchr(__FILE__, '.'), 1);
include($phpbb_root_path . 'common.' . $phpEx);
include($phpbb_root_path . 'includes/functions_display.' . $phpEx);
include($phpbb_root_path . 'includes/bbcode.' . $phpEx);
include($phpbb_root_path . 'includes/message_parser.' . $phpEx);

/**
* Some mod related variables and includes
*/
$dm_linkx_path = (defined('DM_LINKX_ROOT_PATH')) ? DM_LINKX_ROOT_PATH : 'dm_linkx/';
include($phpbb_root_path . $dm_linkx_path . 'common.' . $phpEx);
include($phpbb_root_path . $dm_linkx_path . 'functions_dm_linkx.' . $phpEx);

/**
* Do the session handling
*/
$user->session_begin();
$auth->acl($user->data);
$user->setup(array('viewtopic', 'viewforum', 'mods/dm_linkx'));

/**
* Set some variables
*/
$linkx_id	= request_var('v', 0);
$cat_id 	= request_var('c', 0);
add_form_key('dm_linkx_rating');

/**
* We need som informations about the category we are in for the navigation
*/
$cat_data = get_cat_info($cat_id);

/**
* Generate the navigation
*/
generate_cat_nav($cat_data);

/**
* Generate the sub categories
*/
generate_cat_list($cat_id);

/**
* Select the needed data to show the rating
*/
$sql = 'SELECT linkx_votetotal, linkx_votesum
	FROM ' . DM_LINKX_TABLE . '
	WHERE linkx_id = ' . $linkx_id;
$result = $db->sql_query($sql);
$row = $db->sql_fetchrow($result);
$db->sql_freeresult($result);

$votes = $row['linkx_votetotal'];
$sum = $row['linkx_votesum'];
$avg_score = ($row['linkx_votetotal'] == 0) ? 0 : round($row['linkx_votesum'] / $row['linkx_votetotal'], 2);

/**
* Do the rating stuff
*/
if (!$auth->acl_get('u_dm_linkx_rate'))
{
	$rate_permission = false;
}
else
{
	$rate_permission = true;

	if ( isset($_POST['submit']) )
	{
		$sql = 'SELECT v.linkx_votetotal, v.linkx_votesum, r.*
			FROM ' . DM_LINKX_TABLE . ' v
			LEFT JOIN ' . DM_LINKX_RATE_TABLE . ' r
				ON v.linkx_id = r.linkx_id
			WHERE v.linkx_id = ' . $linkx_id . '
				AND r.user_id = ' . $user->data['user_id'];
		$result = $db->sql_query($sql);
		$row = $db->sql_fetchrow($result);
		$db->sql_freeresult($result);

		if ( !$row['linkx_rating'] )
		{
			$already_rated = false;
		}
		else
		{
			$already_rated = true;
		}
		
		$rating = request_var('linkx_rating', 0);

		$old_rating = $row['linkx_rating'];
		$linkx_votesum = $row['linkx_votesum'];

		// Lets do the linkx ratings...
		if ($rating != 0 && !$already_rated)
		{
			$sql_ary = array(
				'linkx_id'				=> $linkx_id,
				'user_id'				=> $user->data['user_id'],
				'linkx_rating'			=> $rating,
				'rating_date'			=> time(),
				'user_ip'				=> $user->ip,
			);

			$sql = 'INSERT INTO ' . DM_LINKX_RATE_TABLE . ' ' . $db->sql_build_array('INSERT', $sql_ary);
			$db->sql_query($sql);

			$sql = 'UPDATE ' . DM_LINKX_TABLE . '
					SET linkx_votetotal = linkx_votetotal + 1,
						linkx_votesum = linkx_votesum + ' . $rating . '
					WHERE linkx_id = ' . $linkx_id;
			$db->sql_query($sql);
		}
		else if ($rating != 0 && $already_rated)
		{
			if (!check_form_key('dm_linkx_rating'))
			{
				trigger_error($user->lang['FORM_INVALID']);
			}

			$rating_old = $row['linkx_rating'];
			$sql_ary = array(
				'linkx_rating'	=> $rating,
			);

			$sql = 'UPDATE ' . DM_LINKX_RATE_TABLE . ' SET ' . $db->sql_build_array('UPDATE', $sql_ary) . ' WHERE linkx_id = ' . $linkx_id . ' AND user_id = ' . $user->data['user_id'];
			$db->sql_query($sql);

			$new_linkx_votesum = ($linkx_votesum-$old_rating+$rating);
			
			$sql = 'UPDATE ' . DM_LINKX_TABLE . '
					SET linkx_votesum = ' . $new_linkx_votesum . '
					WHERE linkx_id = ' . $linkx_id;
			$db->sql_query($sql);
		}
	}
}

// This will check whether the user has already voted.
$s_hidden_fields = '';

$sql_array = array(
	'SELECT'	=> 'g.linkx_votetotal, g.linkx_votesum, r.*',

	'FROM'		=> array(
		DM_LINKX_TABLE	=> 'g',
	),

	'LEFT_JOIN'	=> array(
		array(
			'FROM'	=> array(DM_LINKX_RATE_TABLE => 'r'),
			'ON'	=> 'g.linkx_id = r.linkx_id'
		)
	),

	'WHERE'		=> 'g.linkx_id = ' . $linkx_id . '
		AND r.user_id = ' . $user->data['user_id'],
);

$sql = $db->sql_build_query('SELECT', $sql_array);
$result = $db->sql_query($sql);
$row = $db->sql_fetchrow($result);
$db->sql_freeresult($result);

$user_rating = ($row['linkx_rating'] == '') ? 0 : $row['linkx_rating'];
$linkx_rating_select = get_rating_select($user_rating);

/**
* Send the variables to the template
*/
$template->assign_vars(array(
	'S_HAS_PERM_RATE'		=> $auth->acl_get('u_dm_linkx_rate'),

	'LINKX_RATING_SELECT'	=> $linkx_rating_select,

	'U_BACK_CAT'			=> append_sid("{$phpbb_root_path}{$dm_linkx_path}viewcat.$phpEx", 'c=' . $cat_id),

	'S_ACTION' 				=> append_sid("{$phpbb_root_path}{$dm_linkx_path}showlinkx.$phpEx", 'v=' . $linkx_id . '&amp;c=' . $cat_id),
	'S_HIDDEN_FIELDS' 		=> $s_hidden_fields,
	)
);
$db->sql_freeresult($result);

/**
* Select the needed data to show the linkx
*/
$sql = 'SELECT v.*, u.username, u.user_id, u.user_colour
	FROM ' . DM_LINKX_TABLE . ' v
	LEFT JOIN ' . USERS_TABLE . ' u
		ON u.user_id = v.linkx_user_id
	WHERE v.linkx_id = ' . $linkx_id;
$result = $db->sql_query($sql);
$row = $db->sql_fetchrow($result);

$linkx_user_id = $row['linkx_user_id'];
$linkx_username = $row['linkx_username'];
$linkx_usercolour = $row['user_colour'];
$linkx_img = $row['linkx_image'];
$desc = generate_text_for_display($row['linkx_desc'], $row['bbcode_uid'], $row['bbcode_bitfield'], $row['bbcode_options']);

/**
* Select the category name
*/
$sql2 = 'SELECT cat_name
	FROM ' . DM_LINKX_CATS_TABLE . '
	WHERE cat_id = ' . $cat_id;
$result = $db->sql_query($sql2);
$row2 = $db->sql_fetchrow($result);

/**
* Count the number of comments
*/
$sql3 = 'SELECT COUNT(comment_id) AS comment_counter
	FROM ' . DM_LINKX_COMMENT_TABLE . '
	WHERE linkx_id = ' . $linkx_id;
$result = $db->sql_query($sql3);
$comment_counter = (int) $db->sql_fetchfield('comment_counter');

if ( $comment_counter == 0 )
{
	$template->assign_vars(array(
		'CC' => $user->lang['DM_LINKX_COMMENT_NO_CC'],
	));
}
elseif ( $comment_counter == 1 )
{
	$template->assign_vars(array(
		'CC' => $user->lang['DM_LINKX_COMMENT_SINGLE'],
	));
}
else
{
	$template->assign_vars(array(
		'CC' => sprintf($user->lang['DM_LINKX_COMMENT_MULTI'], $comment_counter),
	));
}

/**
* Send the variables to the template
*/
$template->assign_vars(array(
	'EDIT_IMG' 				=> $user->img('icon_post_edit', 'EDIT_POST'),
	'DELETE_IMG' 			=> $user->img('icon_post_delete', 'DELETE_POST'),
	'REPORT_IMG'			=> $user->img('icon_post_report', 'REPORT_POST'),

	'S_HAS_PERM_RATE'		=> $rate_permission,
	'S_ADD_LINKX'			=> $auth->acl_get('u_dm_linkx_add'),
	'S_EDIT_LINKX'			=> (($auth->acl_get('u_dm_linkx_edit') && $row['linkx_user_id'] == $user->data['user_id']) || $auth->acl_get('a_dm_linkx_manage')),
	'S_REPORT_LINKX'		=> $auth->acl_get('u_dm_linkx_report'),
	'S_DELETE_LINKX'		=> (($auth->acl_get('u_dm_linkx_del') && $row['linkx_user_id'] == $user->data['user_id']) || $auth->acl_get('a_dm_linkx_manage')),
	'S_SHOW_COMMENTS'		=> $auth->acl_get('u_dm_linkx_comment_view'),
	'U_COMMENT_LINKX'		=> append_sid("{$phpbb_root_path}{$dm_linkx_path}showcomments.$phpEx", 'v=' . $linkx_id . '&amp;c=' . $cat_id),
	'U_EDIT_LINKX'			=> append_sid("{$phpbb_root_path}{$dm_linkx_path}postlinkx.$phpEx", 'mode=edit&amp;v=' . $linkx_id . '&amp;c=' . $cat_id),
	'U_DELETE_LINKX'		=> append_sid("{$phpbb_root_path}{$dm_linkx_path}postlinkx.$phpEx", 'mode=delete&amp;v=' . $linkx_id . '&amp;c=' . $cat_id),
	'U_REPORT_LINKX'		=> append_sid("{$phpbb_root_path}{$dm_linkx_path}reportlinkx.$phpEx", 'v=' . $linkx_id . '&amp;c=' . $cat_id),
	'U_RATE_LINKX'			=> append_sid("{$phpbb_root_path}{$dm_linkx_path}ratelinkx.$phpEx", 'v=' . $linkx_id . '&amp;c=' . $cat_id),

	'LINKX_RATING_IMG' 		=> set_rating_image($votes, $sum, $avg_score),	
	
	'LINKX_CLICKS'			=> ($row['linkx_counter'] == 1) ? $user->lang['DM_LINKX_SINGLE_VIEW'] : sprintf($user->lang['DM_LINKX_MULTI_VIEW'], $row['linkx_counter']),

	'LINKX_ADDED_BY'		=> get_username_string('full', $linkx_user_id, $linkx_username,$linkx_usercolour),
	'LINKX_TITLE' 			=> $row['linkx_title'],
	'LINKX_DESC'			=> $desc,
	'LINKX_LINK' 			=> htmlspecialchars_decode($row['linkx_link']),
	'LINKX_CAT_NAME'		=> $row2['cat_name'],
	'LINKX_TIME'			=> $user->format_date($row['linkx_time']),
	'LINKX_IMAGE'			=> htmlspecialchars_decode($linkx_img),
	'U_BACK_CAT'			=> append_sid("{$phpbb_root_path}{$dm_linkx_path}viewcat.$phpEx", '&amp;c=' . $cat_id),
	)
);
$db->sql_freeresult($result);

/**
* Update the view counter
*/
if (isset($user->data['session_page']) && !$user->data['is_bot'] && strpos($user->data['session_page'], '&amp;c=' . $cat_id) === false)
{
	$db->sql_query('UPDATE ' . DM_LINKX_TABLE . ' SET linkx_counter = linkx_counter + 1 WHERE linkx_id = ' . (int) $linkx_id);
}

/**
* The output of the page
*/
page_header($user->lang['DM_LINKX_LINKX'] . ' &bull; ' . censor_text($row['linkx_title']));

$template->set_filenames(array(
   'body' => $dm_linkx_path . 'showlinkx_body.html'
   )
);

page_footer();

?>