<?php
/**
*
* @package DM Linkx
* @version $Id: topten.php 168 2011-12-21 13:54:36Z femu $
* @copyright (c) 2009 femu - http://die-muellers.org
* @license http://opensource.org/licenses/gpl-license.php GNU Public License
*
*/

/**
* @ignore
*/
define('IN_PHPBB', true);
$phpbb_root_path = (defined('PHPBB_ROOT_PATH')) ? PHPBB_ROOT_PATH : '../';
$phpEx = substr(strrchr(__FILE__, '.'), 1);
include($phpbb_root_path . 'common.' . $phpEx);
include($phpbb_root_path . 'includes/message_parser.' . $phpEx);

/**
* Some mod related variables and includes
*/
$dm_linkx_path = (defined('DM_LINKX_ROOT_PATH')) ? DM_LINKX_ROOT_PATH : 'dm_linkx/';
include($phpbb_root_path . $dm_linkx_path . 'common.' . $phpEx);
include($phpbb_root_path . $dm_linkx_path . 'functions_dm_linkx.' . $phpEx);

/**
* Do the session handling
*/
$user->session_begin();
$auth->acl($user->data);
$user->setup('mods/dm_linkx');

/**
* Check authorisation
*/
$is_authorised = ($auth->acl_get('u_dm_linkx_view') || $auth->acl_get('a_dm_linkx_manage')) ? true : false;

if (!$is_authorised)
{
	trigger_error('NOT_AUTHORISED');
}

/**
* Set the variable show by hits or the rating
*/
$mode = request_var('mode', '');

/**
* Create Top XX Linkxs by hits and ratings
*/

switch($mode)
{
	case 'hits':
		{
			set_top_10_hits();
			
			/**
			* The output of the page
			*/
			page_header($user->lang['DM_LINKX_LINKX'] . ' &bull; ' . $user->lang['DM_LINKX_INDEX']);

			$template->set_filenames(array(
				'body' => $dm_linkx_path . 'topten_hits_body.html'
				)
			);

			page_footer();
		}
	break;
	
	case 'rating':
		{
			set_top_10_rating();
			
			/**
			* The output of the page
			*/
			page_header($user->lang['DM_LINKX_LINKX'] . ' &bull; ' . $user->lang['DM_LINKX_INDEX']);

			$template->set_filenames(array(
				'body' => $dm_linkx_path . 'topten_ratings_body.html'
				)
			);

			page_footer();
		}
	break;
}

?>