<?php
/**
*
* @package DM Linkx
* @version $Id: viewcat.php 168 2011-12-21 13:54:36Z femu $
* @copyright (c) 2009 femu - http://die-muellers.org
* @license http://opensource.org/licenses/gpl-license.php GNU Public License
*
*/

/**
* @ignore
*/
define('IN_PHPBB', true);
$phpbb_root_path = (defined('PHPBB_ROOT_PATH')) ? PHPBB_ROOT_PATH : '../';
$phpEx = substr(strrchr(__FILE__, '.'), 1);
include($phpbb_root_path . 'common.' . $phpEx);
include($phpbb_root_path . 'includes/message_parser.' . $phpEx);

/**
* Some mod related variables and includes
*/
$dm_linkx_path = (defined('DM_LINKX_ROOT_PATH')) ? DM_LINKX_ROOT_PATH : 'dm_linkx/';
include($phpbb_root_path . $dm_linkx_path . 'common.' . $phpEx);
include($phpbb_root_path . $dm_linkx_path . 'functions_dm_linkx.' . $phpEx);

/**
* Do the session handling
*/
$user->session_begin();
$auth->acl($user->data);
$user->setup('mods/dm_linkx');

/**
* Set some variables
*/
$cat_id 	= request_var('c', 0);
$start		= request_var('start', 0);

/**
* We need some information about the cat, we are in
*/
$cat_data = get_cat_info($cat_id);

/**
* Generate the navigation
*/
generate_cat_nav($cat_data);

/**
* Generate the sub categories list
*/
generate_cat_list($cat_id);

/**
* Generate the linkx list
*/
generate_linkx_list($cat_id);

/**
* Send variables to the template
*/
$template->assign_vars(array(
	'LINKX_CAT'			=> false,
	'LINKX_CAT_ID'		=> $cat_data['cat_id'],
	'CAT_NAME'			=> $cat_data['cat_name'],
	'CAT_DESC'			=> generate_text_for_display($cat_data['cat_desc'], $cat_data['cat_desc_uid'], $cat_data['cat_desc_bitfield'], $cat_data['cat_desc_options']),
	'U_LINKX_CAT'		=> append_sid("{$phpbb_root_path}{$dm_linkx_path}viewcat.$phpEx", 'c=' . $cat_data['cat_id']),
	'U_POST_NEW_LINKX'	=> append_sid("{$phpbb_root_path}{$dm_linkx_path}postlinkx.$phpEx", 'mode=new&amp;c=' . $cat_data['cat_id']),
	)
);

/**
* The output of the page
*/
page_header($user->lang['DM_LINKX_LINKX'] . ' &bull; ' . censor_text($cat_data['cat_name']));

$template->set_filenames(array(
	'body' => $dm_linkx_path . 'viewcat_body.html')
);

page_footer();

?>