<?php
/**
*
* @package DM Linkx
* @version $Id: index.php 178 2012-05-28 16:11:03Z femu $
* @copyright (c) 2009, 2010 femu
* @license http://opensource.org/licenses/gpl-license.php GNU Public License
*
*/

/**
* @ignore
*/
define('UMIL_AUTO', true);
define('IN_PHPBB', true);
define('IN_INSTALL', true);
$phpbb_root_path = (defined('PHPBB_ROOT_PATH')) ? PHPBB_ROOT_PATH : './../';
$phpEx = substr(strrchr(__FILE__, '.'), 1);
include($phpbb_root_path . 'common.' . $phpEx);

// Start session management
$user->session_begin();
$auth->acl($user->data);
$user->setup();

if (!file_exists($phpbb_root_path . 'umil/umil_auto.' . $phpEx))
{
	trigger_error('Please download the latest UMIL (Unified MOD Install Library) from: <a href="http://www.phpbb.com/mods/umil/">phpBB.com/mods/umil</a>', E_USER_ERROR);
}

// The name of the mod to be displayed during installation.
$mod_name = 'UMIL_LINKX_TITLE';

/*
* The name of the config variable which will hold the currently installed version
* You do not need to set this yourself, UMIL will handle setting and updating the version itself.
*/

$version_config_name = 'dm_linkx_version';

/*
* The language file which will be included when installing
* Language entries that should exist in the language file for UMIL (replace $mod_name with the mod's name you set to $mod_name above)
*/
$language_file = 'mods/dm_linkx';

/*
* Optionally we may specify our own logo image to show in the upper corner instead of the default logo.
* $phpbb_root_path will get prepended to the path specified
* Image height should be 50px to prevent cut-off or stretching.
*/
$logo_img = 'install/dm_logo.png';

/*
* The array of versions and actions within each.
* You do not need to order it a specific way (it will be sorted automatically), however, you must enter every version, even if no actions are done for it.
*
* You must use correct version numbering.  Unless you know exactly what you can use, only use X.X.X (replacing X with an integer).
* The version numbering must otherwise be compatible with the version_compare function - http://php.net/manual/en/function.version-compare.php
*/

/**
* Define the basic structure
* The format:
*		array('{TABLE_NAME}' => {TABLE_DATA})
*		{TABLE_DATA}:
*			COLUMNS = array({column_name} = array({column_type}, {default}, {auto_increment}))
*			PRIMARY_KEY = {column_name(s)}
*			KEYS = array({key_name} = array({key_type}, {column_name(s)})),
*
*	Column Types:
*	INT:x		=> SIGNED int(x)
*	BINT		=> BIGINT
*	UINT		=> mediumint(8) UNSIGNED
*	UINT:x		=> int(x) UNSIGNED
*	TINT:x		=> tinyint(x)
*	USINT		=> smallint(4) UNSIGNED (for _order columns)
*	BOOL		=> tinyint(1) UNSIGNED
*	VCHAR		=> varchar(255)
*	CHAR:x		=> char(x)
*	XSTEXT_UNI	=> text for storing 100 characters (topic_title for example)
*	STEXT_UNI	=> text for storing 255 characters (normal input field with a max of 255 single-byte chars) - same as VCHAR_UNI
*	TEXT_UNI	=> text for storing 3000 characters (short text, descriptions, comments, etc.)
*	MTEXT_UNI	=> mediumtext (post text, large text)
*	VCHAR:x		=> varchar(x)
*	TIMESTAMP	=> int(11) UNSIGNED
*	DECIMAL		=> decimal number (5,2)
*	DECIMAL:		=> decimal number (x,2)
*	PDECIMAL		=> precision decimal number (6,3)
*	PDECIMAL:	=> precision decimal number (x,3)
*	VCHAR_UNI	=> varchar(255) BINARY
*	VCHAR_CI		=> varchar_ci for postgresql, others VCHAR
*/

$versions = array(
	// Version 1.0.0 - this is the first version using UMIL
	'1.0.0'	=> array(
		// Now to add the tables (this uses the layout from develop/create_schema_files.php and from phpbb_db_tools)
		'table_add' => array(

			array($table_prefix . 'dm_linkx', array(
					'COLUMNS'		=> array(
						'linkx_id'				=> array('UINT:11', NULL, 'auto_increment'),
						'linkx_title'			=> array('VCHAR', ''),
						'linkx_desc'			=> array('MTEXT_UNI', ''),
						'linkx_link'			=> array('VCHAR', ''),
						'linkx_image'			=> array('VCHAR', ''),
						'linkx_user_id'			=> array('UINT:8', 0),
						'linkx_username'		=> array('VCHAR', ''),
						'linkx_time'			=> array('UINT:11', 0),
						'linkx_cat_id'			=> array('UINT:8', 0),
						'linkx_approval'		=> array('TINT:1', 0),
						'linkx_reported'		=> array('TINT:1', 0),
						'linkx_counter'			=> array('UINT:11', 0),
						'linkx_votetotal'		=> array('UINT:8', 0),
						'linkx_votesum'			=> array('UINT:8', 0),
						'last_poster_id'		=> array('UINT:8', 0),
						'last_poster_name'		=> array('VCHAR', ''),
						'last_poster_colour'	=> array('VCHAR:6', ''),
						'last_poster_time'		=> array('UINT:11', 0),
						'last_poster_cat_id'	=> array('UINT:8', 0),
						'bbcode_bitfield'		=> array('VCHAR', ''),
						'bbcode_uid'			=> array('VCHAR:8', ''),
						'bbcode_options'		=> array('UINT:4', 0),
						'enable_magic_url'		=> array('TINT:1', 0),
						'enable_smilies'		=> array('TINT:1', 0),
						'enable_bbcode'			=> array('TINT:1', 0),
					),
					'PRIMARY_KEY'	=> 'linkx_id',
					'KEYS'			=> array(
						'linkx_cat_id'		=> array('INDEX', 'linkx_cat_id'),
						'linkx_user_id'		=> array('INDEX', 'linkx_user_id'),
						'linkx_time'		=> array('INDEX', 'linkx_time'),
					),
				),
			),

			array($table_prefix . 'dm_linkx_cat', array(
					'COLUMNS'		=> array(
						'cat_id'					=> array('UINT:8', NULL, 'auto_increment'),
						'parent_id'					=> array('UINT:8', 0),
						'left_id'					=> array('UINT:8', 0),
						'right_id'					=> array('UINT:8', 0),
						'cat_parents'				=> array('MTEXT_UNI', ''),
						'cat_desc'					=> array('MTEXT_UNI', ''),
						'cat_desc_uid'				=> array('VCHAR:8', ''),
						'cat_desc_bitfield'			=> array('VCHAR:8', 0),
						'cat_desc_options'			=> array('UINT:8', 0),
						'cat_name'					=> array('VCHAR', ''),
						'linkx_last_poster_title'	=> array('VCHAR', ''),
						'linkx_last_poster_id'		=> array('UINT:8', 0),
						'linkx_last_poster_name'	=> array('VCHAR', ''),
						'linkx_last_poster_colour'	=> array('VCHAR:6', ''),
						'linkx_last_linkx_time'		=> array('UINT:11', 0),
					),
					'PRIMARY_KEY'	=> 'cat_id',
				),
			),

			array($table_prefix . 'dm_linkx_comment', array(
					'COLUMNS'		=> array(
						'comment_id'				=> array('UINT:11', NULL, 'auto_increment'),
						'linkx_id'					=> array('UINT:11', 0),
						'linkx_user_id'				=> array('UINT:8', 0),
						'linkx_username'			=> array('VCHAR', ''),
						'linkx_user_colour'			=> array('VCHAR:6', ''),
						'linkx_time'				=> array('UINT:11', 0),
						'linkx_comment'				=> array('MTEXT_UNI', ''),
						'comment_bbcode_bitfield'	=> array('VCHAR', ''),
						'comment_bbcode_options'	=> array('UINT:8', 0),
						'comment_bbcode_uid'		=> array('VCHAR:8', ''),
						'enable_magic_url'			=> array('TINT:1', 0),
						'enable_smilies'			=> array('TINT:1', 0),
						'enable_bbcode'				=> array('TINT:1', 0),
					),
					'PRIMARY_KEY'	=> 'comment_id',
				),
			),

			array($table_prefix . 'dm_linkx_config', array(
					'COLUMNS'		=> array(
						'config_name'				=> array('VCHAR', ''),
						'config_value'				=> array('VCHAR', ''),
					),
				),
			),

			array($table_prefix . 'dm_linkx_rating', array(
					'COLUMNS'		=> array(
						'linkx_id'					=> array('UINT:11', 0),
						'user_id'					=> array('UINT:8', 0),
						'linkx_rating'				=> array('UINT:8', 0),
						'rating_date'				=> array('UINT:11', 0),
						'linkx_time'				=> array('UINT:11', 0),
						'user_ip'					=> array('VCHAR:40', ''),
					),
				),
			),
		),

		// Now to add permission for the DM Linkx
		'permission_add' => array(
			array('u_dm_linkx_view', true),
			array('u_dm_linkx_rate', true),
			array('u_dm_linkx_add', true),
			array('u_dm_linkx_edit', true),
			array('u_dm_linkx_del', true),
			array('u_dm_linkx_report', true),
			array('u_dm_linkx_comment_view', true),
			array('u_dm_linkx_comment_add', true),
			array('u_dm_linkx_comment_edit', true),
			array('u_dm_linkx_comment_del', true),
			array('a_dm_linkx_view', true),
			array('a_dm_linkx_rate', true),
			array('a_dm_linkx_add', true),
			array('a_dm_linkx_edit', true),
			array('a_dm_linkx_del', true),
			array('a_dm_linkx_report', true),
			array('a_dm_linkx_comment_view', true),
			array('a_dm_linkx_comment_add', true),
			array('a_dm_linkx_comment_edit', true),
			array('a_dm_linkx_comment_del', true),
		),

		// Clear the general cache as well as the templates, imagesets and themes cache
		'cache_purge' => array(
			array(),
			array('imageset'),
			array('template'),
			array('theme'),
		),

		// Alright, now lets add some modules to the ACP
		'module_add' => array(
			// First, lets add a new category named ACP_DM_LINKX to ACP_CAT_DOT_MODS
			array('acp', 'ACP_CAT_DOT_MODS', 'ACP_DM_LINKX_DM_LINKX'),

			// Now we will add the config module to the ACP_DM_LINKX_DM_LINKX
			array('acp', 'ACP_DM_LINKX_DM_LINKX', array(
					'module_basename'	=> 'dm_linkx',
					'module_langname'	=> 'ACP_DM_LINKX_CONFIG',
					'module_mode'		=> 'linkx_config',
					'module_auth'		=> 'acl_a_board',
				),
			),

			// Now we will add the categories module to the ACP_DM_LINKX_DM_LINKX
			array('acp', 'ACP_DM_LINKX_DM_LINKX', array(
					'module_basename'	=> 'dm_linkx',
					'module_langname'	=> 'ACP_DM_LINKX_MANAGE_CATEGORIES',
					'module_mode'		=> 'manage_categories',
					'module_auth'		=> 'acl_a_board',
				),
			),

			// Now we will add the manage links module to the ACP_DM_LINKX_DM_LINKX
			array('acp', 'ACP_DM_LINKX_DM_LINKX', array(
					'module_basename'	=> 'dm_linkx',
					'module_langname'	=> 'ACP_DM_LINKX_EDIT',
					'module_mode'		=> 'edit_linkxs',
					'module_auth'		=> 'acl_a_board',
				),
			),

			// Now we will add the release links modul to the ACP_DM_LINKX_DM_LINKX
			array('acp', 'ACP_DM_LINKX_DM_LINKX', array(
					'module_basename'	=> 'dm_linkx',
					'module_langname'	=> 'ACP_DM_LINKX_RELEASE',
					'module_mode'		=> 'release_linkxs',
					'module_auth'		=> 'acl_a_board',
				),
			),

			// Now we will add the reported links modul to the ACP_DM_LINKX_DM_LINKX
			array('acp', 'ACP_DM_LINKX_DM_LINKX', array(
					'module_basename'	=> 'dm_linkx',
					'module_langname'	=> 'ACP_DM_LINKX_REPORTED',
					'module_mode'		=> 'reported_linkxs',
					'module_auth'		=> 'acl_a_board',
				),
			),
		),

		/*
		* Now we need to insert some data.  The easiest way to do that is through a custom function
		* Enter 'custom' for the array key and the name of the function for the value.
		*/
		'custom'	=> 'first_fill_1_0_0',
	),

	// Version 1.0.1 - permisions
	'1.0.1'		=> array(
		// Remove permissions for the DM Linkx, which are no longer needed
		'permission_remove' => array(
			array('a_dm_linkx_view', true),
			array('a_dm_linkx_rate', true),
			array('a_dm_linkx_add', true),
			array('a_dm_linkx_edit', true),
			array('a_dm_linkx_del', true),
			array('a_dm_linkx_report', true),
			array('a_dm_linkx_comment_view', true),
			array('a_dm_linkx_comment_add', true),
			array('a_dm_linkx_comment_edit', true),
			array('a_dm_linkx_comment_del', true),
		),

		// Now to add a new permission for the DM Linkx
		'permission_add' => array(
			array('a_dm_linkx_manage', true),
		),

		// How about we give some default permissions then as well?
		'permission_set' => array(
			array('GUESTS', 'u_dm_linkx_view', 'group'),
			array('GUESTS', 'u_dm_linkx_comment_view', 'group'),
			array('REGISTERED', 'u_dm_linkx_view', 'group'),
			array('REGISTERED', 'u_dm_linkx_rate', 'group'),
			array('REGISTERED', 'u_dm_linkx_add', 'group'),
			array('REGISTERED', 'u_dm_linkx_edit', 'group'),
			array('REGISTERED', 'u_dm_linkx_report', 'group'),
			array('REGISTERED', 'u_dm_linkx_comment_view', 'group'),
			array('REGISTERED', 'u_dm_linkx_comment_add', 'group'),
			array('REGISTERED', 'u_dm_linkx_comment_edit', 'group'),
			array('REGISTERED', 'u_dm_linkx_comment_del', 'group'),
			array('ROLE_ADMIN_STANDARD', 'a_dm_linkx_manage', 'role'),
		),
		// Fill tables
		'custom'	=> 'fill_1_0_1',
	),

	// Version 1.0.2 only update Version
	'1.0.2'		=> array(),

	// Version 1.0.3 only update Version
	'1.0.3'		=> array(),

	// Version 1.0.4 only update Version
	'1.0.4'		=> array(),
);

// Include the UMIF Auto file and everything else will be handled automatically.
include($phpbb_root_path . 'umil/umil_auto.' . $phpEx);

/*
* Here is our custom function that will be called for version 1.0.0
*
* @param string $action The action (install|update|uninstall) will be sent through this.
* @param string $version The version this is being run for will be sent through this.
*/
function first_fill_1_0_0($action, $version)
{
	global $db, $table_prefix, $umil;

	switch ($action)
	{
		case 'install' :
			// Run this when installing the first time
			if ($umil->table_exists($table_prefix . 'dm_linkx_config'))
			{
				// before we fill anything in this table, we truncate it. Maybe someone missed an old installation.
				$db->sql_query('TRUNCATE TABLE ' . $table_prefix . 'dm_linkx_config');

				$sql_ary = array();

				$sql_ary[] = array('config_name' => 'linkx_page_user',		'config_value' => '15',);
				$sql_ary[] = array('config_name' => 'linkx_page_acp',		'config_value' => '15',);
				$sql_ary[] = array('config_name' => 'top_views',			'config_value' => '10',);
				$sql_ary[] = array('config_name' => 'top_ratings',			'config_value' => '10',);
				$sql_ary[] = array('config_name' => 'newest_linkxs',		'config_value' => '5',);
				$sql_ary[] = array('config_name' => 'linkx_page_comment',	'config_value' => '15',);

				$db->sql_multi_insert($table_prefix . 'dm_linkx_config ', $sql_ary);
			}

			// Send the message, that the command was successful
			return 'UMIL_INSERT_FIRST_FILL';
		break;

		case 'update' :
		break;

 		case 'uninstall' :
		break;
	}
}

/*
* Here is our custom function that will be called for version 1.0.1
*
* @param string $action The action (install|update|uninstall) will be sent through this.
* @param string $version The version this is being run for will be sent through this.
*/
function fill_1_0_1($action, $version)
{
	global $db, $table_prefix, $umil;

	switch ($action)
	{
		case 'install' :
		case 'update' :
			// Change the main permission for the modules
			if ($umil->table_exists($table_prefix . 'modules'))
			{
				$sql = "UPDATE " . $table_prefix . "modules
					SET module_auth = 'acl_a_dm_linkx_manage' 
					WHERE module_langname = 'ACP_DM_LINKX_DM_LINKX'";
				$db->sql_query($sql);

				$sql = "UPDATE " . $table_prefix . "modules
					SET module_auth = 'acl_a_dm_linkx_manage' 
					WHERE module_basename = 'dm_linkx'
						AND module_langname = 'ACP_DM_LINKX_CONFIG'";
				$db->sql_query($sql);

				$sql = "UPDATE " . $table_prefix . "modules
					SET module_auth = 'acl_a_dm_linkx_manage' 
					WHERE module_basename = 'dm_linkx'
						AND module_langname = 'ACP_DM_LINKX_MANAGE_CATEGORIES'";
				$db->sql_query($sql);

				$sql = "UPDATE " . $table_prefix . "modules
					SET module_auth = 'acl_a_dm_linkx_manage' 
					WHERE module_basename = 'dm_linkx'
						AND module_langname = 'ACP_DM_LINKX_EDIT'";
				$db->sql_query($sql);

				$sql = "UPDATE " . $table_prefix . "modules
					SET module_auth = 'acl_a_dm_linkx_manage' 
					WHERE module_basename = 'dm_linkx'
						AND module_langname = 'ACP_DM_LINKX_RELEASE'";
				$db->sql_query($sql);

				$sql = "UPDATE " . $table_prefix . "modules
					SET module_auth = 'acl_a_dm_linkx_manage' 
					WHERE module_basename = 'dm_linkx'
						AND module_langname = 'ACP_DM_LINKX_REPORTED'";
				$db->sql_query($sql);

				$sql = "ALTER TABLE " . $table_prefix . "dm_linkx_rating
					CHANGE user_ip user_ip VARCHAR(40) NOT NULL";
				$db->sql_query($sql);
			}

			// Method 1 of displaying the command (and Success for the result)
			return 'UMIL_UPDATE_SUCCESSFUL';
		break;

		case 'uninstall' :
		break;
	}
}

?>